<?php
/*
Extract post or get variables from a script

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 01-07-2023
*/
function ExtractVariables($sSource,$sType=1){
	// default is _POST
	$sPostPattern = '/\$_'.($sType==1 ? 'POST' : 'GET').'\[\'(.*?)\'\]/';
	$aVariableNames = array();
	preg_match_all($sPostPattern,$sSource,$aMatches);
	if(!empty($aMatches[1])){
		$aVariableNames = $aMatches[1];
		$aVariableNames = array_values(array_unique($aVariableNames));
	}
	return($aVariableNames);
}
?>