<?php
/*
Fetches all case value for a switch statement that uses $_POST['submit'] or $_GET['submit']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 01-07-2023
*/
function SwitchDissect($sCode){
	global $sError;
	// find all modules load tags
	preg_match_all('/switch\s*\(\s*\$_(?:GET|POST)\[([\'"])(.*?)\1\]/',$sCode,$aMatches,PREG_SET_ORDER);
	if(isset($aMatches[0]) && $aMatches[0][2]=="submit"){
		// this is what we're looking for, generally speaking var $_POST['submit'] or $_GET['submit'] is used to trigger actions on a screen.php module file
		preg_match_all('/case\s?([\'"]?)(.+?)\1:/',$sCode,$aCases);
		if(count($aCases[2])>0){
			// assuming there's only one switch
			$aData = array();
			$aData['submit'] = $aCases[2];
		}
		else{
			$sError = "No switches found";
			return(false);
		}
	}
	else{
		$sError = "No submit variable switches found";
		return(false);
	}
	return $aData;
}
?>