$(document).on("click","a.cleareditor",function(e){
	e.preventDefault();
	$('textarea.loadshell').val('');
});
$(document).on("click","a.runcode",function(e){
	e.preventDefault();
	const link = $('.runcode');
	var runcode = $('textarea.loadshell').val();
	if(runcode==''){
		alert('No code has been entered in the editor');
		return(false);
	}
	var dataString = "sCode="+runcode;
	$.ajax({
		type: "POST",
		data: dataString,
		url: "JSON/modglue.php",
		dataType: "json",
		beforeSend: function(){
			link.removeAttr('href');
			alert('Don\'t close the screen until the program has finished in the iframe');
		},
		success: function(json){
			if(json.jresult){
				const iframe = $('iframe#screen');
				$('iframe').css('display','none').animate({height:'300px',width:'99%'},500).fadeIn(500);
				iframe.attr('src','modgluerun.php?sCode='+encodeURIComponent(json.jmessage));
			}
			else{
				alert(json.jmessage);
			}
			link.attr('href','#');
		},
		error: function(xhr,textStatus,errorThrown){
			alert(xhr.responseText);
		}
	});
});
$(document).on("click","a.analyze",function(e){
	e.preventDefault();
	var runcode = $('textarea.loadshell').html();
});
$(document).ready(function() {
	$("a.runcode").hide();
	$("a.hideiframe").hide();
	$("a.cleareditor").hide();
	// listen for changes in the textarea
	$("textarea.loadshell").on("input",function(){
		var textareaContent = $(this).val().trim();
		if(textareaContent.length>0){
			$("a.runcode").show();
			if($('iframe#screen').is(':visible')){
				$("a.hideiframe").show();
			}
			else{
				$("a.hideiframe").hide();
			}
			$("a.cleareditor").show();
		}
		else{
			$("a.runcode").hide();
			if($('iframe#screen').is(':visible')){
				$("a.hideiframe").show();
			}
			else{
				$("a.hideiframe").hide();
			}
			$("a.cleareditor").hide();
		}
	});
});