<?php
/*
The file index.php handles all communication between the frontend and the request handlers.

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 23-09-2023
*/
if(!defined('IN_SCRIPT')){
	exit;
}
echo"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
echo"<html xmlns=\"http://www.w3.org/1999/xhtml\">\n";
echo"<head>\n";
echo"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
echo"<meta http-equiv=\"Cache-Control\" content=\"no-store\" />\n";
echo"<title>THC ModGlue</title>\n";
echo"<link rel=\"stylesheet\" type=\"text/css\" href=\"css/style.css\" />\n";
echo"<script type=\"text/javascript\" src=\"../../JS/jquery-1.9.1.min.js\"></script>\n";
echo"<script type=\"text/javascript\" src=\"../../JS/jquery.easing.js\"></script>\n";
echo"<script type=\"text/javascript\" src=\"js/collapse_folder.js\"></script>\n";
echo"<script type=\"text/javascript\" src=\"js/analyze_module.js\"></script>\n";
echo"<script type=\"text/javascript\" src=\"js/view_source.js\"></script>\n";
echo"<script type=\"text/javascript\" src=\"js/sendtoeditor.js\"></script>\n";
echo"<script type=\"text/javascript\" src=\"js/editor.js\"></script>\n";
echo"</head>\n";
echo"<body>\n";
// create the setup form
echo"<center><img src=\"modglue.png\" border=\"0\" /></center>\n";
echo"<form target=\"screen\" action=\"modgluerun.php\" class=\"cracker\" method=\"post\">\n";
echo"<div class=\"formwrap formhighlighter\">\n";
echo"	<div class=\"form\">\n";
echo"		<div class=\"row\" id=\"def\">\n";
echo"			<div class=\"iframe\"><iframe src=\"modgluerun.php\" width=\"0\" height=\"0\" id=\"screen\" target=\"screen\"></iframe></div>\n";
echo"		</div>\n";
echo"		<div class=\"clear\"></div>\n";
echo"		<div class=\"xplain\">\n";
echo"			<div class=\"fieldhighlighter\">This application is a pseudo code interpreter and code analyzer that binds hacksuite modules.</div>\n";
echo"		</div>\n";
echo"		<div class=\"clear\"></div>\n";
echo"		<div class=\"row\">\n";
echo"			<div class=\"progress\"><div class=\"nojs red\">this application requires javascript to be enabled in your browser</div></div>\n";
echo"		</div>\n";
echo"		<div class=\"clear\"></div>\n";
echo"		<div class=\"row\" id=\"def\">\n";
echo"			<div><textarea cols=\"75\" rows=\"15\" name=\"sShellData\" class=\"loadshell\"></textarea>\n";
echo"		</div>\n";
echo"		<div class=\"clear\"></div>\n";
echo"		<div class=\"row\" id=\"def\">\n";
echo"			<a href=\"#\" class=\"hideiframe\">[hide iframe]</a> <a href=\"#\" class=\"cleareditor\">[clear editor]</a> <a href=\"#\" class=\"runcode\">[run code]</a>\n";
echo"		</div>\n";
echo"		<div class=\"clear\"></div>\n";
echo"		<div class=\"row\" id=\"def\">\n";
echo"			<div class=\"txtbig\">Installed Modules</div>\n";
echo"		</div>\n";
echo"		<div class=\"clear\"></div>\n";
echo"		<div class=\"row\" id=\"modules\">\n";
foreach($_CONTEXT['modglue']['folders'] as $sModule=>$aFiles){
	include("../../Modules/".$sModule."/setup.php");
	echo"			<div class=\"modfolder\">".$sModule." ".$aProperties['version']." - ".$aProperties['name']." (<a href=\"#\" class=\"analyzefile\" id=\"".$sModule."\">analyze properties</a>)</div>\n";
	echo"			<div class=\"modreport\" id=\"".$sModule."\"></div>\n";
	echo"			<div class=\"modload\" id=\"".$sModule."\"></div>\n";
	echo"			<div class=\"modfiles\" id=\"".$sModule."\">\n";
	echo"				<div class=\"txtbig\">Readable files in ".$aProperties['name']."</div>\n";
	for($x=0;$x<count($aFiles);$x++){
		echo"				<div class=\"modfile\"><a href=\"#\" class=\"vwsrc\" id=\"".$sModule."\" title=\"".$aFiles[$x]."\">".$aFiles[$x]."</a></div>\n";
	}
	echo"			</div>\n";
}
echo"		</div>\n";
echo"		<div class=\"clear\"></div>\n";
echo"		<div class=\"row\" id=\"submitit\">\n";
echo"			<div class=\"text\"></div>\n";
echo"			<div class=\"input\">".(!empty($sSelectWord) && $bProduct ? "<input type=\"submit\" name=\"submit\" class=\"submit\" value=\"Submit\" /> <a href=\"../black\">[ switch to black ]</a> <a href=\"#\" class=\"cfglink\">[ database profiler ]</a>" : "")." <a href=\"../../index.php\">[ home ]</a></div>\n";
echo"		</div>\n";
echo"	</div>\n";
echo"</div>\n";
echo"</form>\n";
echo"<script type=\"text/javascript\">\n";
// remove no javascript message, if it's still there then no js is enabled
echo"\$('div.nojs').remove();\n";
echo"</script>\n";
echo"</body>\n";
echo"</html>";
?>