<?php
/* Handler for Parasite returns json encoded content

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 29-06-2017
*/
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
define('PARASITE_ROOT',"../");
$_DYNAMIC_ROOT = "../../..";
include_once("../../../header.php");
include_once("../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
$aDataR['jmessage'] = "an error occured";
if(isset($_POST['sProduct'])){
	/* fetch all accounts for this product */
	$aProduct = @explode(":",trim($_POST['sProduct']));
	if(!isset($aProduct[1])){
		$aDataR['jmessage'] = "Invalid product specified";
	}
	else{
		if(!preg_match('/^[0-9a-z_\-]+$/i',$aProduct[0]) || !preg_match('/^[0-9]+\.?[0-9]+$/i',$aProduct[1])){
			$aDataR['jmessage'] = "Product name or version contains invalid characters";
		}
		else{
			if(!$cGen->IsSupportedProduct($_CONTEXT['gen']['products'],$aProduct[0],$aProduct[1])){
				$aDataR['jmessage'] = "Product doesn't exist";
			}
			else{
				// backup folder
				$sBackupFolder = "../backup/".$aProduct[0]."/".$aProduct[1];
				// set filepaths for product data
				$sDestAccounts = "../connect_data/".$aProduct[0]."/".$aProduct[1]."/accounts.php";
				$sDestDBFields = "../query_data/".$aProduct[0]."/".$aProduct[1]."/parasite_db.php";
				$sDestExtendClass = "../classes/".$aProduct[0]."/".$aProduct[1]."/".$aProduct[0].".php";
				// handlers for Parasite actions
				if(isset($_POST['iActions'])){
					$_POST['iActions'] = @intval($_POST['iActions']);
					$sDest = "../includes/actions/".$_POST['iActions'].".php";
					if(!file_exists($sDest)){
						$aDataR['jmessage'] = "Handler for this action doesn't exist";
					}
					else{
						include($sDest);
					}
				}
				elseif(isset($_POST['sProfileX'])){
					// returns recovery profiles
					include($sDestAccounts);
					$sBackupFolder = "";
					for($x=0;$x<count($aAccounts);$x++){
						if($aAccounts[$x]['profile_name']==$_POST['sProfileX']){
							$sBackupFolder = $aAccounts[$x]['database_backup'];
						}
					}
					if($sBackupFolder==""){
						$aDataR['jmessage'] = "No backup folder found";
					}
					else{
						if(!function_exists("GetFilesByDirectory")){
							include_once($_PATHS['functions_root']."/getfilebydir.php");
						}
						$aFiles = GetFilesByDirectory("../backup/".$aProduct[0]."/".$aProduct[1]."/".$sBackupFolder);
						if(false==($iFiles = @count($aFiles))){
							$aDataR['jmessage'] = "No files in backup folder";
						}
						else{
							rsort($aFiles);
							$sSelect = "<select name=\"sFileX\">";
							for($x=0;$x<$iFiles;$x++){
								$aTime = explode(".",$aFiles[$x]);
								$sSelect .= "<option value=\"".$aFiles[$x]."\">".$aFiles[$x]." - ".date("d-m-Y H:i",$aTime[0])."</option>";
							}
							$sSelect .= "</select>";
							$aDataR['jresult'] = true;
							$aDataR['jbackups'] = $sSelect;
						}
					}

				}
				else{
					/* DEFAULT */
					$sDest = "../includes/actions/0.php";
					include($sDest);
				}
			}
		}
	}
}
else{
	$aDataR['jmessage'] = "No product selected";
}
echo json_encode($aDataR);
?>