<?php
/* Creates fake acounts

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 28-03-2019
*/
if(!defined('IN_SCRIPT')){
	exit;
}
$bProceed = false;
$aAccounts = array();
$iProfile = 0;
include($sDestExtendClass);
$cParasite = new ProductSpecific();
$cParasite->SetProduct($cGen->GetProduct());
$cParasite->SetVersion($cGen->GetVersion());
if(@filesize($sDestAccounts)!=false){
	// there are accounts that we can use for validation
	include($sDestAccounts);
	for($x=0;$x<count($aAccounts);$x++){
		if($aAccounts[$x]['profile_name']==$_POST['sProfileName']){
			$bProceed = true;
			$aAccounts = $aAccounts[$x];
			$iProfile = $x;
			break;
		}
	}
	if(!$cParasite->ConnectDB($aAccounts['database_host'],$aAccounts['database_name'],$aAccounts['database_user'],$aAccounts['database_pass'])){
		$aDataR['jmessage'] = "Please check your credentials, failed to connect to database";
		$bProceed = false;
	}
}
if($bProceed){
	if($_POST['sWordlist']==""){
		$aDataR['jmessage'] = "No wordlist specified";
	}
	elseif($_POST['iUsers']==""){
		$aDataR['jmessage'] = "No amount of accounts has been set";
	}
	else{
		$_POST['iUsers'] = @intval($_POST['iUsers']);
		if(!is_int($_POST['iUsers']) || $_POST['iUsers']<1){
			$aDataR['jmessage'] = "Invalid amount of accounts specified";
		}
		else{
			// validate wordlist file name and content
			if(!preg_match('/^[0-9a-z_\-]+\.[a-z]+$/i',$_POST['sWordlist'])){
				$aDataR['jmessage'] = "Invalid file name";
			}
			$sDest = "../../../Wordlists/".$_POST['sWordlist'];
			if(!file_exists($sDest)){
				$aDataR['jmessage'] = "Wordlist doesn't exist, make sure you have it installed in the Wordlists folder";
			}
			else{
				if(!filesize($sDest)){
					$aDataR['jmessage'] = "Wordlist is empty";
				}
				else{
					// let's insert account into the database table
					$cParasite->SetPrefix($aAccounts['database_table_prefix']);
					$cParasite->SetTable($aAccounts['database_table_users']);
					if($cParasite->GetUsers($sDest)===false){
						$aDataR['jmessage'] = "Failed to set users";
					}
					else{
						if($_POST['iUsers']>$cParasite->GetAmountAccounts()){
							$aDataR['jmessage'] = "Wordlist doesn't have enough words";
						}
						else{
							$iFails = 0;
							for($x=0;$x<$_POST['iUsers'];$x++){
								if(false==($sUser = $cParasite->MakeUser())){
									$aDataR['jmessage'] = "Failed to create username";
									break;
								}
								if($cParasite->UserExists($sUser)){
									if($iFails>10){
										break;
									}
									$iFails++;
								}
								$aQuery['username'] = $sUser;
								$aQuery = $cParasite->SetAccountSettings($aQuery);
								$cParasite->InsertQuery($aQuery);
							}
							if($iFails!=0){
								$aDataR['jmessage'] = "Failed to insert (".$iFails."/".$_POST['iUsers'].") user accounts";
							}
							else{
								$aDataR['jresult'] = true;
							}
						}
					}
				}
			}
		}
	}
}
else{
	$aDataR['jmessage'] = "Profile doesn't exist";
}
?>