<?php
/* Truncates a wordlist

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 29-06-2017
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if($_POST['sWordlist']==""){
	$aDataR['jmessage'] = "No wordlist specified";
}
else{
	// validate wordlist file name and content
	if(!preg_match('/^[0-9a-z_\-]+\.[a-z]+$/i',$_POST['sWordlist'])){
		$aDataR['jmessage'] = "Invalid file name";
	}
	$sDest = $_PATHS['wordlists_root']."/".$_POST['sWordlist'];
	if(!file_exists($sDest)){
		$aDataR['jmessage'] = "Wordlist doesn't exist, make sure you have it installed in the Wordlists folder";
	}
	else{
		if(false==($aFile = @file($sDest))){
			$aDataR['jmessage'] = "Wordlist doesn't have valid content";
		}
		else{
			/*
			- remove passwords smaller than 8 characters
			- remove passwords bigger than 12 characters
			- remove passwords containing period characters
			- remove passwords that are entirely made of numbers
			*/
			if(!$cGen->TruncateUsernameFile($sDest)){
				$aDataR['jmessage'] = $cGen->GetLastError();
			}
			else{
				$aDataR['jmessage'] = "Successfully truncated username file";
				$aDataR['jresult'] = true;
			}
		}
	}
}
?>