<?php
/*
Native configuration pages

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 21-03-2024
*/
if(!defined("IN_SCRIPT")){
	exit;
}
$_CONTEXT['native'] = array();
$_CONTEXT['native'][0] = array("configuration editor","edit_config.php","edit_config","edit your configuration files and its default values","configure");
$_CONTEXT['native'][1] = array("debug environment","debug.php","debug_config","debug context, paths and other variables","debugging");
$_CONTEXT['native'][2] = array("install app","new_page.php","add_config","add new apps to the hacksuite's environment","expand");
$_CONTEXT['native'][3] = array("recover files","recover.php","recover_config","recover your configuration files and reset them to default values","security");
$_CONTEXT['native'][4] = array("change style","style_manager.php","style_config","change the look and feel of the hacksuite","styling");
$_CONTEXT['native'][5] = array("rss configure","remote.php","rss_config","allows you to manage remote rss sources","configure");
$_CONTEXT['native'][6] = array("log manager","logmanager.php","log_config","total manager for setting up and handling log files","security");
$_CONTEXT['native'][7] = array("proxy manager","proxy_manager.php","proxy_config","total manager for handling and importing proxies","expand");
$_CONTEXT['native'][8] = array("dorking and sql","dorks.php","dork_config","configure dork files and the sql errors","expand");
$_CONTEXT['native'][9] = array("widgets","widgets.php","widgets_config","manager for the sidebar search widgets","expand");
$_CONTEXT['native'][10] = array("appearance","appearance.php","appearance_config","changes the amount of links in the menubar","styling");
$_CONTEXT['native'][11] = array("task killer","task_kill.php","task_kill_config","removes finished tasks or cleans the task data file","debugging");
$_CONTEXT['native'][12] = array("security manager","security_manager.php","security_manager_config","manages your hacksuite security configuration","security");
$_CONTEXT['native'][13] = array("database connecter","db_connect.php","db_config","manages medusa database connections","security");
$_CONTEXT['native'][14] = array("shell manager","shell.php","shell_config","manages medusa shells","security");
$_CONTEXT['native'][15] = array("wordlist manager","wordlistimport.php","wordlist_config","manages wordlists","expand");
$_CONTEXT['native'][16] = array("servermap manager","map.php","map_config","manages existing server maps to increase security","configure");
$_CONTEXT['native'][17] = array("screen limitations","screensetup.php","as_config","configures carnivore memory and time limit setup in screen files","configure");
$_CONTEXT['native'][18] = array("reset environment","reset.php","reset_config","resets suite and deletes results data","configure");
$_CONTEXT['native'][19] = array("set version","set.php","version_config","sets current version of the hacksuite cms","configure");
$_CONTEXT['native'][20] = array("maintenance scan","maintenance_scan.php","maintenance_config","configures all of the maintenance scanner properties","configure");
$_CONTEXT['native'][21] = array("antievil configuration","antievil.php","antievil_config","configures properties for the antievil scanner","configure");
$_CONTEXT['native'][22] = array("testserver manager","server_manager.php","testserver_config","enables or disables access to test servers","configure");
$_CONTEXT['native'][23] = array("path editor","path_edit.php","editpath_config","changes paths to hacksuite folders","security");
$_CONTEXT['native'][24] = array("logpath editor","log_edit.php","editlog_config","changes names of hacksuite logs","security");
$_CONTEXT['native'][25] = array("set time pattern","time_edit.php","time_config","changes time patterns","configure");
?>