<?php
/* Verifies core functions existence

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 12-02-2015
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if($_CONTEXT['allow_functcheck']){
	$_CONTEXT['scanlabel']['missing_func'] = "missing functions";
	$_CONTEXT['missing_func'] = "";
	// load the data directory file that contains all core functions or throw a fatal error
	$aRequire = array($_PATHS['data_root']."/core_functions.php");
	for($x=0;$x<count($aRequire);$x++){
		(!IsThere($aRequire[$x]) ? include_once($_PATHS['end']) : include_once($aRequire[$x]));
	}
	for($x=0;$x<count($_CONTEXT['core_functions']);$x++){
		$sDest = $_PATHS['functions_root']."/".$_CONTEXT['core_functions'][$x];
		// normally I'd throw a fatal here, but we want to be able to let the user download the file and install it automatically
		if(!file_exists($sDest)){
			$_CONTEXT['missing_func'] .= "					<div class=\"deleterow".$x."\"><a href=\"#\" class=\"rdownload\" id=\"".$x."\" title=\"".$_CONTEXT['core_functions'][$x]."\">download and install <b>".$_CONTEXT['core_functions'][$x]."</b></a></div>\n";
		}
	}
	$_CONTEXT['scandata']['missing_func'] = $_CONTEXT['missing_func'];
}
?>