<?php
/* Security notifications

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 20-04-2018
*/
if(!defined('IN_SCRIPT')){
	exit;
}
$_CONTEXT['sec_notes'] = "";
// detect if a bruteforce attack has taken place
include_once($_PATHS['includes_root']."/detect_bf.php");
if(isset($_CONTEXT['bf_detected'])){
	// check if a bruteforce attack has been detected
	$_CONTEXT['sec_notes'] .= "							<div class=\"cc_record\">\n";
	$_CONTEXT['sec_notes'] .= "								<div class=\"flt pad3\" id=\"bf\">- <a href=\"#\" class=\"mlink\" id=\"bf\">Possible bruteforce attack on login</a></div>\n";
	$_CONTEXT['sec_notes'] .= "							</div>\n";
	$_CONTEXT['sec_notes'] .= "							<div class=\"clear\"></div>\n";
}
if(!$_CONTEXT['pass_access']){
	// password access
	$_CONTEXT['sec_notes'] .= "							<div class=\"cc_record\">\n";
	$_CONTEXT['sec_notes'] .= "								<div class=\"flt pad3\" id=\"nopass\">- <a href=\"#\" class=\"mlink\" id=\"nopass\">No password has been set for your environment</a></div>\n";
	$_CONTEXT['sec_notes'] .= "							</div>\n";
	$_CONTEXT['sec_notes'] .= "							<div class=\"clear\"></div>\n";
}
if(!$_CONTEXT['ip_access']){
	// ip access
	$_CONTEXT['sec_notes'] .= "							<div class=\"cc_record\">\n";
	$_CONTEXT['sec_notes'] .= "								<div class=\"flt pad3\" id=\"noip\">- <a href=\"#\" class=\"mlink\" id=\"noip\">Environment is possibly accessible from any ip address</a></div>\n";
	$_CONTEXT['sec_notes'] .= "							</div>\n";
	$_CONTEXT['sec_notes'] .= "							<div class=\"clear\"></div>\n";
}
if(isset($_CONTEXT['rtasks']) && $_CONTEXT['rtasks']>0){
	// tasks that still run after a day
	$_CONTEXT['sec_notes'] .= "							<div class=\"cc_record\">\n";
	$_CONTEXT['sec_notes'] .= "								<div class=\"flt pad3\" id=\"toolong\">- <a href=\"#\" class=\"mlink\" id=\"toolong\">Found ".$_CONTEXT['rtasks']." task".($_CONTEXT['rtasks']!=1 ? "s" : "")." running for at least a day</a></div>\n";
	$_CONTEXT['sec_notes'] .= "							</div>\n";
	$_CONTEXT['sec_notes'] .= "							<div class=\"clear\"></div>\n";
}
$aLogFolder = explode("/",$_PATHS['log_root']);
if($aLogFolder[count($aLogFolder)-1]=="Logs"){
	// you might want to change your Log folder, because some files can be readable and directly accessible through an http request
	$_CONTEXT['sec_notes'] .= "							<div class=\"cc_record\">\n";
	$_CONTEXT['sec_notes'] .= "								<div class=\"flt pad3\" id=\"samelog\">- <a href=\"#\" class=\"mlink\" id=\"samelog\">You might want to change the path of your log folder</a></div>\n";
	$_CONTEXT['sec_notes'] .= "							</div>\n";
	$_CONTEXT['sec_notes'] .= "							<div class=\"clear\"></div>\n";
}
// see if we have notifications to show
if($_CONTEXT['sec_notes']!=""){
	$_CONTEXT['sec_notes'] = "						<div class=\"cc_summary emboss borderr5 border1pxtrans pad5 edgeglow\">\n<div class=\"embosshdrnocenter border1pxtrans pad5\">Security Notifications</div>\n".$_CONTEXT['sec_notes']."</div>\n";
	$_CONTEXT['htmlo'] = str_replace("</head>","<script type=\"text/javascript\" src=\"Templates/".$_PATHS['style_user']."/js/tooltip.js\"></script>\n</head>",$_CONTEXT['htmlo']);

}
?>