<?php
/* Determines whether modules and apps are still up-to-date

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 16-02-2019
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if($_CONTEXT['allow_version_check']){
	$_CONTEXT['scanlabel']['version_check'] = "version check";
	$_CONTEXT['version_check'] = "";
	$aBranch = explode(".",$_CONTEXT['version']);
	// validate modules
	foreach($_CONTEXT['modules'] as $sKey=>$aValues2){
		$aBranchModule = explode(".",$aValues2['version']);
		if($aBranchModule[1]!=$aBranch[1]){
			$_CONTEXT['version_check'] .= "Module <b>".$sKey."</b> is designed for a different branch.<br />\n";
		}
	}
	if(false!=($iExtra = @count($aExtra))){
		// validate apps
		for($x=0;$x<$iExtra;$x++){
			$sApp = $aExtra[$x][0];
			$sFolder = $aExtra[$x][1];
			include_once($sFolder."/setup.php");
			$aBranchModule = explode(".",$aProperties['version']);
			if($aBranchModule[1]!=$aBranch[1]){
				$_CONTEXT['version_check'] .= "Application <b>".$aProperties['name']."</b> is designed for a different branch.<br />\n";
			}
		}
	}
	else{
		$_CONTEXT['version_check'] .= "Application data wasn't loaded, expecting this data to be present.<br />\n";
	}
	$_CONTEXT['scandata']['version_check'] = $_CONTEXT['version_check'];
}
?>