<?php
/* Module creation form

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 12-12-2023
*/
if(!defined('IN_SCRIPT')){
	exit;
}
$sCode .= "						<form method=\"post\" class=\"developform\">\n";
$sCode .= "						<div class=\"cc_summary emboss borderr5 border1pxtrans pad5 edgeglow\">\n";
$sCode .= "							<div class=\"embosshdrnocenter border1pxtrans pad5\">create new module</div>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"a\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">name of module</div><div class=\"flt pad3 w200\"><input type=\"text\" name=\"sName\" value=\"\" title=\"name of the module\" size=\"35\" /><br /><small>name of the module</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"b\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">abbreviation</div><div class=\"flt pad3 w200\"><input type=\"text\" name=\"sAbbr\" value=\"thc_??\" title=\"abbreviation: eg thc_ss\" size=\"35\" max_length=\"6\" /><br /><small>abbreviation and foldername of module</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"c\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">description</div><div class=\"flt pad3 w200\"><textarea name=\"sDescription\" value=\"\" cols=\"35\" rows=\"15\" title=\"description for the module\"></textarea><br /><small>explain what the module does</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"d\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">version</div><div class=\"flt pad3 w200\"><input type=\"text\" name=\"sVersion\" value=\"0.6.2\" title=\"version of the module\" /><br /><small>version of carnivore that this module is compatible with</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"e\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">author</div><div class=\"flt pad3 w200\"><input type=\"text\" name=\"sAuthor\" value=\"\" title=\"author of the module\" /><br /><small>nickname or your name</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"j\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">url</div><div class=\"flt pad3 w200\"><input type=\"text\" name=\"sUrl\" value=\"\" title=\"url of your website\" /><br /><small>your website of leave empty</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"f\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">keywords</div><div class=\"flt pad3 w200\"><input type=\"text\" name=\"sTags\" value=\"\" title=\"related tags for the module separated by comma\" /><br /><small>related keywords to this module separated by a comma</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"g\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">add screen file</div><div class=\"flt pad3 w200\"><input type=\"checkbox\" class=\"screenf\" name=\"iScreenFile\" value=\"1\" title=\"add a screen file\" /><br /><small>if you want to use an iframe to send the content to, note that it is recommended for modglue compatibility</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"ghide\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">no time limit</div><div class=\"flt pad3 w200\"><input type=\"checkbox\" name=\"iTimeLimit\" value=\"1\" title=\"set time limit to 0\" /><br /><small>check this option for modules that may take a lot of time to execute such as bruteforce programs</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"h\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">add data file</div><div class=\"flt pad3 w200\"><input type=\"checkbox\" class=\"dataf\" name=\"iDataFile\" value=\"1\" title=\"add a data file\" /><br /><small>adds a datafile to save content</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"hhide\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">name of file</div><div class=\"flt pad3 w200\"><input type=\"text\" name=\"sDataFile\" value=\"\" title=\"data file name\" /><br /><small>name of the datafile <i>file.extension</i>, if file doesn't match this pattern the file will be named <i>accounts.php</i> instead</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
// create existing module selection menu
$sCategoryMods = "\n			<select name=\"sModCat\">\n";
$sCategoryMods .= "				<option value=\"-1\">select a category</option>\n";
foreach($_CONTEXT['modcats'] as $sCat=>$aValues){
	$sCategoryMods .= "				<option value=\"".$sCat."\">".str_replace("_"," ",$sCat)."</option>\n";
}
$sCategoryMods .= "			</select>\n";
$sCode .= "							<div class=\"cc_record modrow\" id=\"i\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">category</div><div class=\"flt pad3 w200\">".$sCategoryMods."<br /><small>category that describes your module best</small></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
// after module has been created
$sCode .= "							<div class=\"cc_record modrow\" id=\"indexcontent\">\n";
$sCode .= "								<div class=\"flt pad3 w150\">index.php</div><div class=\"flt pad3 w300\"><textarea id=\"code\" name=\"sIndex\" rows=\"25\" cols=\"55\" class=\"editorfield\"></textarea></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "							<div class=\"cc_record modrow\">\n";
$sCode .= "								<div class=\"modrowleft flt pad3 w150\"></div><div class=\"flt pad3 w200\"><input type=\"submit\" id=\"newfile\" value=\"add new file\" /><input type=\"hidden\" name=\"createmod\" value=\"1\" /><input type=\"submit\" name=\"submit\" class=\"newmodule\" value=\"Create\" /></div>\n";
$sCode .= "							</div>\n";
$sCode .= "							<div class=\"clear\"></div>\n";
$sCode .= "						</div>\n";
$sCode .= "						</form>\n";
?>