<?php
/* Time editor

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 21-02-2024
*/
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "..";
include_once("../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
$aDataR['jmessage'] = "An error occured";
$aFiles = array($_PATHS['functions_root']."/fwrite.php",$_PATHS['functions_root']."/get_file_data.php");
for($x=0;$x<count($aFiles);$x++){
	if(!file_exists($aFiles[$x])){
		$_CONTEXT['errors'][] = array('error'=>'Missing required file: '.$aFiles[$x],'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
		include_once($_PATHS['end']);
	}
	@include_once($aFiles[$x]);
}
if(isset($_POST['sTime'])){
	// update time pattern setting
	$_POST['sTime'] = @trim($_POST['sTime']);
	$sDest = $_PATHS['root']."/vars.php";
	if(!file_exists($sDest)){
		$_CONTEXT['errors'][] = array('error'=>'File vars.php doesn\'t exist','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
		include_once($_PATHS['end']);
	}
	if($_POST['sTime']!="d-m-Y" && $_POST['sTime']!="m-d-Y"){
		$aDataR['jmessage'] = "Invalid time pattern";
	}
	else{
		// determine whether it's necessary to do the update
		if(false==($sFileData = GetFileData($sDest))){
			$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to get data from vars.php','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
			include_once($_PATHS['end']);
		}
		else{
			$sF1 = md5($sFileData);
			$sSearch = "\$_CONTEXT['time_pattern'] = \"".$_CONTEXT['time_pattern']."\";";
			$sReplace = "\$_CONTEXT['time_pattern'] = \"".$_POST['sTime']."\";";
			$sFileData = str_replace($sSearch,$sReplace,$sFileData);
			$sF2 = md5($sFileData);
			if($sF1==$sF2){
				$aDataR['jmessage'] = "Nothing to update";
			}
			else{
				if(!WriteF($sDest,$sFileData,"w")){
					$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Data file isn\'t writable','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				else{
					$aDataR['jresult'] = true;
					$aDataR['jmessage'] = "Successfully changed pattern";
				}
			}
		}
	}
}
echo json_encode($aDataR);
?>