<?php
/*
Log file handlers

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 11-06-2023
*/
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header('Content-type: application/json');
$aDataR = array();
$aDataR['jresult'] = false;
$aDataR['jmessage'] = "Invalid action specified";
$_DYNAMIC_ROOT = "../../../";
include_once("../../../header.php");
if(!function_exists("GetFilesByDirectory")){
	$sDest = $_PATHS['functions_root']."/getfilebydir.php";
	if(!file_exists($sDest)){
		$aDataR['jmessage'] = "Can't find GetFilesByDirectory function";
		die(json_encode($aDataR));
	}
	include_once($sDest);
}
// get a list of all log files that are in the logs folder
$aDirs = GetFilesByDirectory("../logs");
$iDirs = @count($aDirs);
if(isset($_POST['sAction'])){
	switch($_POST['sAction']){
		// view log files
		case"View":
		if(!isset($aDirs[0])){
			$aDataR['jmessage'] = "No files in the log folder";
		}
		else{
			$aDataR['jmessage'] = $aDirs;
			$aDataR['jresult'] = true;
		}
		break;
		// view log file
		case"Open":
		if(!in_array($_POST['sFile'],$aDirs)){
			$aDataR['jmessage'] = "No such file exists in the log folder";
		}
		else{
			if(!function_exists("GetFileData")){
				$sDest = $_PATHS['functions_root']."/get_file_data.php";
				if(!file_exists($sDest)){
					$aDataR['jmessage'] = "Can't find GetFileData function";
					die(json_encode($aDataR));
				}
				include_once($sDest);
			}
			$sFileData = GetFileData(nl2br($sDest));
			$aDataR['jmessage'] = $sFileData;
			$aDataR['jresult'] = true;
		}
		break;
		// delete log file
		case"Delete":
		if(!in_array($_POST['sFile'],$aDirs)){
			$aDataR['jmessage'] = "No such file exists in the log folder";
		}
		else{
			if(!@unlink("../logs/".$_POST['sFile'])){
				$aDataR['jmessage'] = "Failed to remove file from logs folder";
			}
			else{
				$aDataR['jmessage'] = "Successfully removed file from logs folder";
				$aDataR['jresult'] = true;
			}
		}
		break;
		// drop all logfiles
		case"Clean Folder":
		if(!isset($aDirs[0])){
			$aDataR['jmessage'] = "No files in this folder";
		}
		else{
			$iDeleted = 0;
			for($x=0;$x<count($aDirs);$x++){
				if(@unlink("../logs/".$aDirs[$x])){
					$iDeleted++;
				}
			}
			if($iDeleted!=$iDirs){
				$aDataR['jmessage'] = "Not all files were successfully deleted: (".$iDeleted."/".$iDirs.")";
			}
			else{
				$aDataR['jmessage'] = "Successfully removed files";
				$aDataR['jresult'] = true;
			}
		}
		break;
	}
}
echo json_encode($aDataR);
?>