/* select a file or enter targets manually in textarea */
$(document).on("change","select.type",function(){
	var selectedOption = $(this).val();
	var textField;
	var explain;
	if(selectedOption=='1'){
		textField = $('<textarea>').attr('name','sFileData');
		explain = '<small>enter domains,hosts or urls separated by a new line, pipe symbol or comma</small>';
		$('select.type').hide();
	}
	else if(selectedOption=='2'){
		textField = $('<input>').attr('type','text').attr('name','sFile');
		explain = '<small>enter file location containing domains,hosts or urls separated by a new line, pipe symbol or comma</small>';
		$('select.type').hide();
	}
	else{
		return(false);
	}
	$('.modright#inputtarget').append(textField);
	$('.modright#inputtarget').append('<br />'+explain);
});
/* create interface items for log file handling */
$(document).on("change","select.logactions",function(e){
	e.preventDefault();
	if($(this).val()=="-1"){
		return(false);
	}
	$.ajax({
		type: "POST",
		data: "sAction="+$(this).val(),
		url: "Modules/thc_cp/json/loghandler.php",
		dataType: "json",
		success: function(json){
			if(json.jresult==false){
				alert(json.jmessage);
			}
			else{
				if(Array.isArray(json.jmessage)){
					$(".modrowleft#datalogs").empty();
					for(var i=0;i<json.jmessage.length;i++){
						var item = json.jmessage[i];
						$(".modrowleft#datalogs").append(item);
						$(".modrowleft#datalogs").append(" [<a href=\"#\" class=\"managelogs\" title=\""+item+"\">view</a>] [<a href=\"#\" class=\"managelogs\" title=\""+item+"\">delete</a>]<br />");
					}
				}
				else if(typeof json.jmessage==="string"){
					alert(json.jmessage);
				}
			}
		}
	});
});
/* view or delete logfile content */
$(document).on("click","a.managelogs",function(e){
	e.preventDefault();
	var sendquery = '';
	if($(this).html()=="view"){
		sendquery = "sAction=Open&sFile="+$(this).attr('title');
	}
	else{
		sendquery = "sAction=Delete&sFile="+$(this).attr('title');
	}
	$.ajax({
		type: "POST",
		data: sendquery,
		url: "Modules/thc_cp/json/loghandler.php",
		dataType: "json",
		success: function(json){
			$(".modrowleft#datalogs").html(json.jmessage);
			if(json.jresult==false){
				alert(json.jmessage);
			}
		}
	});
});
/* shows the proper interface items when options link is clicked */
$(document).ready(function(){
	$(".modrow#newform").hide();
	$("a#logs").click(function(event){
		event.preventDefault();
		var div = $('.modright#inputtarget');
		var elementsToDelete = div.children().not('select');
		elementsToDelete.remove();
		$('select.type').show();
		$(".modrow#newform").show();
		$(".modrow#mainform").hide();
	});
	$("a#main").click(function(event){
		event.preventDefault();
		$(".modrow#newform").hide();
		$(".modrow#mainform").show();
	});
});