<?php
/* Handler for xDNS

ModGlue Variables:
$_CONTEXT['thc_dn']['urlparts']
$_CONTEXT['thc_dn']['host']
$_CONTEXT['thc_dn']['dnsdata']
$_CONTEXT['thc_dn']['dnsrecords']
$_CONTEXT['thc_dn']['dnsstring']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 31-10-2023
*/
set_time_limit(0);
$_MODULE_C = "thc_dn";
$_CONTEXT['thc_dn'] = array();
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		/* Retrieve */
		case"Retrieve":
		$_CONTEXT['thc_dn']['urlparts'] = @parse_url($_POST['sHost']);
		if(isset($_CONTEXT['thc_dn']['urlparts']['path']) && $_CONTEXT['thc_dn']['urlparts']['path']==$_POST['sHost']){
			$_CONTEXT['thc_dn']['host'] = $_CONTEXT['thc_dn']['urlparts']['path'];
		}
		else{
			if(isset($_CONTEXT['thc_dn']['urlparts']['scheme'])){
				$_CONTEXT['thc_dn']['host'] = $_CONTEXT['thc_dn']['urlparts']['host'];
			}
			else{
				die(Screen("Invalid host or url specified",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		if(false!=($_CONTEXT['thc_dn']['dnsdata'] = @dns_get_record($_CONTEXT['thc_dn']['host'],DNS_ANY))){
			$_CONTEXT['thc_dn']['dnsrecords'] = count($_CONTEXT['thc_dn']['dnsdata']);
			$_CONTEXT['thc_dn']['dnsstring'] = "";
			for($x=0;$x<$_CONTEXT['thc_dn']['dnsrecords'];$x++){
				$_CONTEXT['thc_dn']['dnsstring'] .= "<b>RECORD ".($x+1).":</b><br />\n";
				foreach($_CONTEXT['thc_dn']['dnsdata'][$x] as $sKey=>$mValue){
					if($sKey=="pri"){
						$sKey = "priority";
					}
					if(is_array($mValue)){
						$mValue = implode(", ",$mValue);
					}
					$_CONTEXT['thc_dn']['dnsstring'] .= "<b>".$sKey.":</b> ".$mValue."<br />\n";
				}
				$_CONTEXT['thc_dn']['dnsstring'] .= "<br />\n<br />\n";
			}
			echo Screen($_CONTEXT['thc_dn']['dnsstring'],$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		else{
			echo Screen("No DNS data",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		break;
		default:
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
?>