<?php
/* THC Dork Handler

ModGlue Variables:
$_CONTEXT['thc_do']['dorkstringfile']
$_CONTEXT['thc_do']['dorkselectfile']
$_CONTEXT['thc_do']['dorkstring']
$_CONTEXT['thc_do']['google']['dorksafe']
$_CONTEXT['thc_do']['google']['dorkout']
$_CONTEXT['thc_do']['google']['dorkenc']
$_CONTEXT['thc_do']['google']['query']['q']
$_CONTEXT['thc_do']['google']['query']['start']
$_CONTEXT['thc_do']['google']['harvest']
$_CONTEXT['thc_do']['google']['max']
$_CONTEXT['thc_do']['google']['query']
$_CONTEXT['thc_do']['google']['searchurl']
$_CONTEXT['thc_do']['google']['searchurldyn']
$_CONTEXT['thc_do']['google']['agent']
$_CONTEXT['thc_do']['google']['timeout']
$_CONTEXT['thc_do']['google']['referer']['dynamic']
$_CONTEXT['thc_do']['google']['reject']
$_CONTEXT['thc_do']['google']['regexes']['multipg']
$_CONTEXT['thc_do']['google']['regexes']['multipg2']
$_CONTEXT['thc_do']['google']['regexes']['linkharvest']
$_CONTEXT['thc_do']['google']['page']
$_CONTEXT['thc_do']['pagesource']
$_CONTEXT['thc_do']['linksharvested']
$_CONTEXT['thc_do']['linksamount']
$_CONTEXT['thc_do']['abort']
$_CONTEXT['thc_do']['urlpatterns']
$_CONTEXT['thc_do']['href']
$_CONTEXT['thc_do']['stringresults']
$_CONTEXT['thc_do']['save']
$_CONTEXT['thc_do']['resultsfile']
$_CONTEXT['thc_do']['resultsave']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 07-05-2024
*/
// set variable to be able to save a task
$_MODULE_C = "thc_do";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
include_once($_PATHS['functions_root']."/fwrite.php");
$_CONTEXT['thc_do'] = array();
$_CONTEXT['thc_do']['dorkstringfile'] = $_PATHS['data_root']."/googledorks.txt";
$_CONTEXT['thc_do']['dorkselectfile'] = $_PATHS['includes_root']."/dorkssqlhandler.php";
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
if(!isset($_POST['submit'])){
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
if($_POST['submit']!="Save" && $_POST['submit']!="View"){
	die(Screen("<p><b>Invalid value for submission button</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// prepare the dork
$_CONTEXT['thc_do']['dorkstring'] = isset($_POST['sDork']) ? trim($_POST['sDork']) : "";
if($_POST['iMode']==1 && $_CONTEXT['thc_do']['dorkstring']==""){
	die(Screen("<p><b>No search string specified</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
elseif($_CONTEXT['thc_do']['dorkstring']==""){
	// ok we gotta have iDork
	if(!isset($_POST['iDork']) || !is_numeric($_POST['iDork'])){
		die(Screen("<p><b>No array index specified for dork data</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
	else{
		$iDork = intval($_POST['iDork']);
		include_once($_CONTEXT['thc_do']['dorkselectfile']);
		if(!isset($_CONTEXT['dorks'][$iDork])){
			die(Screen("<p><b>Invalid array index for dork data</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		$_CONTEXT['thc_do']['dorkstring'] = trim($_CONTEXT['dorks'][$iDork]);
	}
}
// get google dorking properties
include_once($_PATHS['module_default_root']."/gdork.php");
if(!isset($_CONTEXT['thc_do']['google'])){
	die(Screen("<p><b>Properties for google dorking haven't been loaded</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// dork formats
$_CONTEXT['thc_do']['google']['dorksafe'] = $_CONTEXT['thc_do']['dorkstring'];
$_CONTEXT['thc_do']['google']['dorkout'] = htmlspecialchars($_CONTEXT['thc_do']['dorkstring']);
$_CONTEXT['thc_do']['google']['dorkenc'] = urlencode($_CONTEXT['thc_do']['dorkstring']);
$_CONTEXT['thc_do']['google']['query']['q'] = $_CONTEXT['thc_do']['google']['dorkenc'];
$_CONTEXT['thc_do']['google']['harvest'] = array();
$_CONTEXT['thc_do']['google']['max'] = $_POST['iAmount']==-1 ? 10 : intval($_POST['iAmount']);
// construct rest of the search url
foreach($_CONTEXT['thc_do']['google']['query'] as $sParameter=>$sValue){
	$_CONTEXT['thc_do']['google']['searchurl'] .= $sParameter."=".$sValue."&";
}
$_CONTEXT['thc_do']['google']['searchurl'] = substr($_CONTEXT['thc_do']['google']['searchurl'],0,-1);
// its part of the query but is dynamic
$_CONTEXT['thc_do']['google']['query']['start'] = 0;
include($_PATHS['includes_root']."/task_start.php");
echo Screen("<p><b>querying google for ".htmlspecialchars($_CONTEXT['thc_do']['google']['dorkout']).":</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
flush();
ob_flush();
// we'll loop through pages until we extracted enough results or there are no (more) results
while(true){
	// get results in google
	$_CONTEXT['thc_do']['google']['searchurldyn'] = $_CONTEXT['thc_do']['google']['searchurl'].($_CONTEXT['thc_do']['google']['query']['start']==0 ? "" : "&start=".$_CONTEXT['thc_do']['google']['query']['start']);
	$ch = @curl_init();
	@curl_setopt($ch, CURLOPT_URL, $_CONTEXT['thc_do']['google']['searchurldyn']);
	@curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	@curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	@curl_setopt($ch, CURLOPT_USERAGENT, $_CONTEXT['thc_do']['google']['agent']);
	@curl_setopt($ch, CURLOPT_TIMEOUT, $_CONTEXT['thc_do']['google']['timeout']);
	@curl_setopt($ch, CURLOPT_REFERER, $_CONTEXT['thc_do']['google']['referer']['dynamic']);
	$_CONTEXT['thc_do']['pagesource'] = @curl_exec($ch);
	curl_close($ch);
	// extract results...provided we have any..
	preg_match_all($_CONTEXT['thc_do']['google']['regexes']['linkharvest'],$_CONTEXT['thc_do']['pagesource'],$_CONTEXT['thc_do']['linksharvested']);
	if(false==($_CONTEXT['thc_do']['linksamount'] = count($_CONTEXT['thc_do']['linksharvested'][1]))){
		echo Screen("<p><b>aborting indexing, no results on page ".$_CONTEXT['thc_do']['google']['page']."</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		break;
	}
	// importing results
	$_CONTEXT['thc_do']['abort'] = false;
	for($x=0;$x<$_CONTEXT['thc_do']['linksamount'];$x++){
		// sometimes duplicates show up in the results
		if(!in_array($_CONTEXT['thc_do']['linksharvested'][1][$x],$_CONTEXT['thc_do']['google']['harvest'])){
			// check if domain name is blacklisted
			preg_match('/(http[s]?:\/\/)(www\.)?([^\.]+)/',$_CONTEXT['thc_do']['linksharvested'][1][$x],$_CONTEXT['thc_do']['urlpatterns']);
			if(!in_array($_CONTEXT['thc_do']['urlpatterns'][3],$_CONTEXT['thc_do']['google']['reject'])){
				$_CONTEXT['thc_do']['google']['harvest'][] = $_CONTEXT['thc_do']['linksharvested'][1][$x];
			}
		}
		// continue scraping links on this page until we have enough or we need a new page
		if(count($_CONTEXT['thc_do']['google']['harvest'])==$_CONTEXT['thc_do']['google']['max']){
			$_CONTEXT['thc_do']['abort'] = true;
			break;
		}
	}
	if($_CONTEXT['thc_do']['abort']){
		echo Screen("<p><b>aborting indexing, found <b>".count($_CONTEXT['thc_do']['google']['harvest'])."</b> results in Google</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		break;
	}
	else{
		echo Screen("<p><b>result page ".$_CONTEXT['thc_do']['google']['page']." returned ".$_CONTEXT['thc_do']['linksamount']." url".($_CONTEXT['thc_do']['linksamount']!=1 ? "s" : "")."</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		flush();
		ob_flush();
	}
	// so do we have a next page?
	if(!preg_match($_CONTEXT['thc_do']['google']['regexes']['multipg'],$_CONTEXT['thc_do']['pagesource'])){
		if(!preg_match($_CONTEXT['thc_do']['google']['regexes']['multipg2'],$_CONTEXT['thc_do']['pagesource'],$_CONTEXT['thc_do']['href'])){
			sleep(1);
			echo Screen("<p><b>aborting indexing, no more pages after page ".$_CONTEXT['thc_do']['google']['page']."</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			break;
		}
	}
	// onto the next page
	$_CONTEXT['thc_do']['google']['page']++;
	$_CONTEXT['thc_do']['google']['query']['start'] = count($_CONTEXT['thc_do']['google']['harvest']);
	// ok so we'll use this current search page as referer for the next call
	$_CONTEXT['thc_do']['google']['referer']['dynamic'] = $_CONTEXT['thc_do']['google']['searchurldyn'];
}
$_CONTEXT['thc_do']['stringresults'] = "";
if(count($_CONTEXT['thc_do']['google']['harvest'])>1){
	$_CONTEXT['thc_do']['stringresults'] = implode("<br />\n",$_CONTEXT['thc_do']['google']['harvest']);
}
elseif(isset($_CONTEXT['thc_do']['google']['harvest'][0])){
	$_CONTEXT['thc_do']['stringresults'] = $_CONTEXT['thc_do']['google']['harvest'][0];
}
$_CONTEXT['thc_do']['stringresults'] = trim($_CONTEXT['thc_do']['stringresults']);
switch($_POST['submit']){
	/* View */
	case"View":
	echo Screen($_CONTEXT['thc_do']['stringresults'],$_CONTEXT['verbose'],$_CONTEXT['silent']);
	break;
	/* Save */
	case"Save":
	$_CONTEXT['thc_do']['save'] = intval($_POST['iSave']);
	$_CONTEXT['thc_do']['resultsfile'] = $_PATHS['module_default_root']."/RESULTS/".time().".txt";
	if($_CONTEXT['thc_do']['save']==1){
		// save dork
		WriteF($_CONTEXT['thc_do']['dorkstringfile'],(filesize($_CONTEXT['thc_do']['dorkstringfile'])>0 ? "\n" : "").$_CONTEXT['thc_do']['google']['dorksafe'],"a");
	}
	// save results
	$_CONTEXT['thc_do']['resultsave'] = WriteF($_CONTEXT['thc_do']['resultsfile'],strip_tags($_CONTEXT['thc_do']['stringresults']),"w");
	echo Screen(($_CONTEXT['thc_do']['resultsave'] ? "Successfully saved results" : "Failed to save results"),$_CONTEXT['verbose'],$_CONTEXT['silent']);
	break;
	default:
	echo Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
// update entry in background task file
include($_PATHS['includes_root']."/task_end.php");
echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>