<?php
/* Enumerates usernames from FTP

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 07-10-2023
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if(false==($_CONTEXT['thc_en']['ftp_connection'] = @fsockopen($_POST['sInput'],$_CONTEXT['thc_en']['port'],$iError,$sError,10))){
	die(Screen("Failed to make a connection with the specified host.<br />\n".$sError." (".$iError.")",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
$_CONTEXT['thc_en']['ftp_response'] = fread($_CONTEXT['thc_en']['ftp_connection'],1024);
$_CONTEXT['thc_en']['ftp_response_code'] = substr($_CONTEXT['thc_en']['ftp_response'],0,3);
echo Screen(nl2br($_CONTEXT['thc_en']['ftp_response'])."<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
flush();
ob_flush();
// send command to test whether or not the server tells when the user account exists
$_CONTEXT['thc_en']['fake_user'] = "cwedchwjchdswcbdscdsbcbecdsjh";
$_CONTEXT['thc_en']['ftp_command_test'] = "USER ".$_CONTEXT['thc_en']['fake_user']."\r\n";
@fputs($_CONTEXT['thc_en']['ftp_connection'],$_CONTEXT['thc_en']['ftp_command_test']);
$_CONTEXT['thc_en']['ftp_response'] = fread($_CONTEXT['thc_en']['ftp_connection'],1024);
$_CONTEXT['thc_en']['ftp_response_code'] = substr($_CONTEXT['thc_en']['ftp_response'],0,3);
echo Screen("Analyze response to fake user account..<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
flush();
ob_flush();
if($_CONTEXT['thc_en']['ftp_response_code']=="331"){
	// ftp tells the user exists when it doesn't, nope we won't be able to enumerate
	echo Screen("Can't enumerate users from this ftp server<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
else{
	for($x=0;$x<$_CONTEXT['thc_en']['userscount'];$x++){
		// server responds the way we want, if we get a 331 status we can be sure the account exists
		$_CONTEXT['thc_en']['ftp_last_command'] = "USER ".$_CONTEXT['thc_en']['users'][$x]."\r\n";
		@fputs($_CONTEXT['thc_en']['ftp_connection'],$_CONTEXT['thc_en']['ftp_last_command']);
		$_CONTEXT['thc_en']['ftp_response'] = fread($_CONTEXT['thc_en']['ftp_connection'],1024);
		$_CONTEXT['thc_en']['ftp_response_code'] = substr($_CONTEXT['thc_en']['ftp_response'],0,3);
		if($_CONTEXT['thc_en']['ftp_response_code']=="331"){
			$_CONTEXT['thc_en']['valid'][] = $_CONTEXT['thc_en']['users'][$x];
			// user exists
			echo Screen("<b id=\"h6\">User ".$_CONTEXT['thc_en']['users'][$x]." exists</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		else{
			echo Screen("User ".$_CONTEXT['thc_en']['users'][$x]." doesn't exist<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		flush();
		ob_flush();
	}
}
@fclose($_CONTEXT['thc_en']['ftp_connection']);
echo Screen("<p>Tried to enumerate ".$_CONTEXT['thc_en']['userscount']." user".($_CONTEXT['thc_en']['userscount']!=1 ? "s" : "").": ".count($_CONTEXT['thc_en']['valid'])." successfully enumerated</p>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>