<?php
/* Windows IIS Check - applicationHost.config file

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 15-08-2024
*/
if(!defined("IN_SCRIPT")){
	exit;
}
$_CONTEXT['thc_hf']['winiis'] = array();
$_CONTEXT['thc_hf']['winiis'][0] = array("Check if Server Tokens are minimized","//system.webServer/security/requestFiltering[@removeServerHeader='true']");
$_CONTEXT['thc_hf']['winiis'][1] = array("Check if Directory Browsing is disabled","//system.webServer/directoryBrowse[@enabled='false']");
$_CONTEXT['thc_hf']['winiis'][2] = array("Check if SSL is enforced (requires HTTPS)","//system.webServer/security/access[@sslFlags='Ssl']");
$_CONTEXT['thc_hf']['winiis'][3] = array("Check if Request Filtering is enabled","//system.webServer/security/requestFiltering");
$_CONTEXT['thc_hf']['winiis'][4] = array("Check if IP Restrictions are configured","//system.webServer/security/ipSecurity");
?>