<?php
/*
Handler for Investigate

ModGlue Variables:
$_CONTEXT['thc_in']['results']
$_CONTEXT['thc_in']['conclusion']
$_CONTEXT['thc_in']['continue']
$_CONTEXT['thc_in']['items']
$_CONTEXT['thc_in']['filedata']
$_CONTEXT['thc_in']['find']
$_CONTEXT['thc_in']['resultstostring']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 12-05-2024
*/
// set variable to be able to save a task
$_MODULE_C = "thc_in";
$_CONTEXT['thc_in'] = array();
$_CONTEXT['thc_in']['results'] = array();
$_CONTEXT['thc_in']['conclusion'] = false;
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['module_default_root']."/data.php");
include_once($_PATHS['module_default_root']."/investigate.php");
include_once($_PATHS['functions_root']."/scrn.php");
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// scan
		case"Investigate":
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		$_CONTEXT['thc_in']['continue'] = false;
		if(false!=($_CONTEXT['thc_in']['items'] = count($_POST['aItems']))){
			$_CONTEXT['thc_in']['continue'] = true;
			for($x=0;$x<$_CONTEXT['thc_in']['items'];$x++){
				if(!isset($_POST['aItems'][$x])){
					$_CONTEXT['thc_in']['continue'] = false;
					break;
				}
			}
		}
		else{
			die(Screen("<br>\n<b>Invalid selections made</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		if(false==($_CONTEXT['thc_in']['filedata'] = @file_get_contents($_POST['sSearch']))){
			if(function_exists("curl_init")){
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, $_POST['sSearch']);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
				if(false==($_CONTEXT['thc_in']['filedata'] = @curl_exec($ch))){
					die(Screen("<br>\n<b>Failed to get url data, curl fallback method failed</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
				}
				else{
					curl_close($ch);
				}
			}
			die(Screen("<br>\n<b>Failed to get url data</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		include($_PATHS['includes_root']."/task_start.php");
		echo Screen("<br>\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		// spit fire...
		flush();
		ob_flush();
		$cDiscover = new Investigate($_CONTEXT['thc_in']['filedata']);
		for($x=0;$x<$_CONTEXT['thc_in']['items'];$x++){
			echo Screen("<br>\n<b>Testing on ".$_CONTEXT['thc_in']['find'][$x][0]."..</b>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			flush();
			ob_flush();
			$cDiscover->{$_CONTEXT['thc_in']['find'][$x][1]}();
		}
		$_CONTEXT['thc_in']['conclusion'] = true;
		$_CONTEXT['thc_in']['results'] = $cDiscover->GetDetected();
		$_CONTEXT['thc_in']['resultstostring'] = "";
		foreach($_CONTEXT['thc_in']['results'] as $sType=>$aValues){
			if($_CONTEXT['thc_in']['resultstostring']==""){
				$_CONTEXT['thc_in']['resultstostring'] = "<p><b>Results for scan:</b><br />\n";
			}
			$sValues = implode(",",$aValues);
			$_CONTEXT['thc_in']['resultstostring'] .= "<b>".ucfirst(str_replace("_"," ",$sType)).":</b> ".($sValues=="" ? "no results found" : $sValues)."<br />\n";
		}
		if($_CONTEXT['thc_in']['resultstostring']==""){
			$_CONTEXT['thc_in']['resultstostring'] = "No results found";
		}
		$_CONTEXT['thc_in']['resultstostring'] .= "</p>\n";
		echo Screen($_CONTEXT['thc_in']['resultstostring'],$_CONTEXT['verbose'],$_CONTEXT['silent']);
		break;
		// just show index
		default:
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// update entry in background task file
include($_PATHS['includes_root']."/task_end.php");
echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>