<?php
/* xPerformance

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 01-09-2023
*/
if(!defined("IN_SCRIPT")){
	exit;
}
if(!function_exists("GetFilesByDirectory")){
	$sDest = $_PATHS['functions_root']."/getfilebydir.php";
	(!IsThere($sDest) ? include_once($_PATHS['end']) : include_once($sDest));
}
$_CONTEXT['thc_pe'] = array();
$_CONTEXT['thc_pe']['scripts'] = GetFilesByDirectory($_PATHS['module_default_root']."/scripts",0);
$_CONTEXT['thc_pe']['scriptscount'] = @count($_CONTEXT['thc_pe']['scripts']);
$_CONTEXT['thc_pe']['scriptsselect'] = "n/a";
if($_CONTEXT['thc_pe']['scriptscount']>0){
	$_CONTEXT['thc_pe']['scriptsselect'] = "<select name=\"aScript[]\" class=\"scripts\" id=\"options\" multiple>\n";
	for($x=0;$x<$_CONTEXT['thc_pe']['scriptscount'];$x++){
		// let's make the file selection menu
		$_CONTEXT['thc_pe']['scriptsselect'] .= "	<option value=\"".$_CONTEXT['thc_pe']['scripts'][$x]."\">".$_CONTEXT['thc_pe']['scripts'][$x]."</option>\n";
	}
	$_CONTEXT['thc_pe']['scriptsselect'] .= "</select>\n";
}
// report select
$_CONTEXT['thc_pe']['reportselect'] = "<select name=\"iReport\" class=\"reports\">\n";
$_CONTEXT['thc_pe']['reportselect'] .= "	<option value=\"0\">text stats</option>\n";
$_CONTEXT['thc_pe']['reportselect'] .= "	<option value=\"1\">graphic</option>\n";
$_CONTEXT['thc_pe']['reportselect'] .= "</select>\n";
// method select
$_CONTEXT['thc_pe']['methodselect'] = "<select name=\"iMethod\" class=\"methods\">\n";
$_CONTEXT['thc_pe']['methodselect'] .= "	<option value=\"0\">ABABAB</option>\n";
$_CONTEXT['thc_pe']['methodselect'] .= "	<option value=\"1\">AAABBB</option>\n";
$_CONTEXT['thc_pe']['methodselect'] .= "</select>\n";
/* keeps track of the current row when defining properties, which makes it easier to add and remove new rows */
$_CONTEXT['mfs']['currentrow'] = 0;
/* form properties */
$_CONTEXT['mfs']['module'] = $_CONTEXT['module_current'];
$_CONTEXT['mfs']['form'] = array();
$_CONTEXT['mfs']['form']['target'] = $_CONTEXT['screen']['name'];
$_CONTEXT['mfs']['form']['method'] = "post";
$_CONTEXT['mfs']['form']['id'] = "compareit";
$_CONTEXT['mfs']['form']['action'] = $_CONTEXT['screen']['src'];
/* table */
$_CONTEXT['mfs']['table'] = array();
/* table header */
$_CONTEXT['mfs']['table']['header'] = array();
$_CONTEXT['mfs']['table']['header']['name'] = $_CONTEXT['modules'][$_CONTEXT['mfs']['module']]['name'];
$_CONTEXT['mfs']['table']['header']['description'] = $_CONTEXT['modules'][$_CONTEXT['mfs']['module']]['description'];
/* table rows */
$_CONTEXT['mfs']['table']['rows'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "comparescript";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "scripts";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $_CONTEXT['thc_pe']['scriptsselect']."<br /><i>two files need to be specfied from the scripts folder of this module</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "comparescript";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "cycles";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<input type=\"text\" name=\"iCycles\" placeholder=\"3\" size=\"1\" maxlength=\"1\" /><br /><i>times you want to load each script</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "comparescript";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "method";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $_CONTEXT['thc_pe']['methodselect']."<br /><i>in what order are scripts run</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "comparescript";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "type of report";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $_CONTEXT['thc_pe']['reportselect']."<br /><i>text based or graphic(gd) based results</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "script";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "script 1";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<textarea cols=\"30\" rows=\"15\" name=\"sScript1\"></textarea><br /><i>enter php code</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "script";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "script name";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<input type=\"text\" name=\"sScriptName1\" placeholder=\"script1.php\" /><br /><i>times you want to load each script</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "script";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "script 2";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<textarea cols=\"30\" rows=\"15\" name=\"sScript2\"></textarea><br /><i>enter php code</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "script";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "script name";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<input type=\"text\" name=\"sScriptName2\" placeholder=\"script2.php\" /><br /><i>name of the script</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['value'] = "<div class=\"modrowleft mt5\"><input type=\"submit\" name=\"submit\" class=\"bcompare\" value=\"Compare\" /> <input type=\"submit\" name=\"submit\" class=\"bcreate\" value=\"Create\" /> <a href=\"#\" class=\"openeditor\">create scripts</a></div>";
// create output form
$sCode = ModForm($_CONTEXT['mfs']);
// js
$sCode .= "<script type=\"text/javascript\">\n";
$sCode .= "\$(document).ready(function(){\n";
$sCode .= "	\$(\".modrow#script\").hide();\n";
$sCode .= "	\$(\"input.bcreate\").hide();\n";
$sCode .= "});\n";
$sCode .= "\$(\"a.openeditor\").click(function(e){\n";
$sCode .= "	e.preventDefault();\n";
$sCode .= "	if(\$(\".modrow#script\").is(\":visible\")){\n";
$sCode .= "		\$(\".modrow#comparescript\").show();\n";
$sCode .= "		\$(\".modrow#script\").hide();\n";
$sCode .= "		\$(\"input.bcreate\").hide();\n";
$sCode .= "		\$(\"input.bcompare\").show();\n";
$sCode .= "		\$(\"#prf\").attr('id','compareit');\n";
$sCode .= "		$(this).text('create scripts');\n";
$sCode .= "	}\n";
$sCode .= "	else{\n";
$sCode .= "		\$(\".modrow#comparescript\").hide();\n";
$sCode .= "		\$(\".modrow#script\").show();\n";
$sCode .= "		\$(\"input.bcreate\").show();\n";
$sCode .= "		\$(\"input.bcompare\").hide();\n";
$sCode .= "		\$(\"#compareit\").attr('id','prf');\n";
$sCode .= "		$(this).text('back to performance');\n";
$sCode .= "	}\n";
$sCode .= "});\n";
$sCode .= "function validateSelection(){\n";
$sCode .= "	const selectElement = document.getElementById('options');\n";
$sCode .= "	const selectedOptions = Array.from(selectElement.selectedOptions);\n";
$sCode .= "	const compareForm = document.getElementById('compareit');\n";
$sCode .= "	if(selectedOptions.length!==2 && compareForm){\n";
$sCode .= "		alert('Select two scripts to compare performance');\n";
$sCode .= "		event.preventDefault();\n";
$sCode .= "		return(false);\n";
$sCode .= "	}\n";
$sCode .= "}\n";
$sCode .= "document.getElementById('compareit').addEventListener('submit',validateSelection);\n";
$sCode .= "</script>\n";
?>