<?php
/*
Handler for xPerformance

ModGlue Variables:
$_CONTEXT['thc_pe']['scriptstotest']
$_CONTEXT['thc_pe']['scriptsfolder']
$_CONTEXT['thc_pe']['scripts']
$_CONTEXT['thc_pe']['requestedscriptsnumber']
$_CONTEXT['thc_pe']['requestedscripts']
$_CONTEXT['thc_pe']['startscript']
$_CONTEXT['thc_pe']['cycles']
$_CONTEXT['thc_pe']['method']
$_CONTEXT['thc_pe']['report']
$_CONTEXT['thc_pe']['totalcycles']
$_CONTEXT['thc_pe']['result']
$_CONTEXT['thc_pe']['lastscript']
$_CONTEXT['thc_pe']['resultavg']
$_CONTEXT['thc_pe']['printresults']['time_start']
$_CONTEXT['thc_pe']['printresults']['time_end']
$_CONTEXT['thc_pe']['printresults']['results']
$_CONTEXT['thc_pe']['script1']
$_CONTEXT['thc_pe']['script2']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 25-05-2024
*/
set_time_limit(0);
$_MODULE_C = "thc_pe";
$_CONTEXT['thc_pe'] = array();
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
$_CONTEXT['thc_pe']['scriptstotest'] = 2;
$_CONTEXT['thc_pe']['scriptsfolder'] = $_PATHS['module_default_root']."/scripts";
if(!function_exists("GetFilesByDirectory")){
	$sDest = $_PATHS['functions_root']."/getfilebydir.php";
	(!IsThere($sDest) ? include_once($_PATHS['end']) : include_once($sDest));
}
echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
// only files from this folder can be used
$_CONTEXT['thc_pe']['scripts'] = GetFilesByDirectory($_CONTEXT['thc_pe']['scriptsfolder'],0);
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		/* Compare */
		case"Compare":
		if(isset($_POST['aScript'])){
			if(!function_exists("GetFilesByDirectory")){
				$sDest = $_PATHS['functions_root']."/getfilebydir.php";
				(!IsThere($sDest) ? include_once($_PATHS['end']) : include_once($sDest));
			}
			echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
			// only files from this folder can be used
			$_CONTEXT['thc_pe']['scripts'] = GetFilesByDirectory($_CONTEXT['thc_pe']['scriptsfolder'],0);
			// need two files to compare
			if($_CONTEXT['thc_pe']['scriptstotest']==($_CONTEXT['thc_pe']['requestedscriptsnumber'] = @count($_POST['aScript']))){
				$_CONTEXT['thc_pe']['requestedscripts'] = $_POST['aScript'];
				if($_POST['aScript'][0]!=$_POST['aScript'][1]){
					// do the files exist in the scripts folder
					if(in_array($_POST['aScript'][0],$_CONTEXT['thc_pe']['scripts']) && in_array($_POST['aScript'][1],$_CONTEXT['thc_pe']['scripts'])){
						if(!isset($_POST['iReport']) || $_POST['iReport']!=1){
							// text stats default
							$_POST['iReport'] = 0;
						}
						if(!isset($_POST['iMethod']) || $_POST['iMethod']!=1){
							// ABABAB method default
							$_POST['iMethod'] = 0;
						}
						$_POST['iCycles'] = @intval($_POST['iCycles']);
						if(!$_POST['iCycles'] || ($_POST['iCycles']<1 || $_POST['iCycles']>9)){
							// 3 cycles default
							$_POST['iCycles'] = 3;
						}
						$_CONTEXT['thc_pe']['startscript'] = time();
						$_CONTEXT['thc_pe']['cycles'] = $_POST['iCycles'];
						$_CONTEXT['thc_pe']['method'] = $_POST['iMethod'];
						$_CONTEXT['thc_pe']['report'] = $_POST['iReport'];
						$_CONTEXT['thc_pe']['totalcycles'] = $_POST['iCycles'] * $_CONTEXT['thc_pe']['requestedscriptsnumber'];
						$_CONTEXT['thc_pe']['result'] = array();
						$_CONTEXT['thc_pe']['lastscript'] = 0;
						include($_PATHS['includes_root']."/task_start.php");
						// the reason we're using a weird variable name is because we don't want to interfere with the possible loops in the scripts we're going to test
						for($iIncrementalMental=0;$iIncrementalMental<$_CONTEXT['thc_pe']['totalcycles'];$iIncrementalMental++){
							$_CONTEXT['thc_pe']['result'][$iIncrementalMental] = array();
							$_CONTEXT['thc_pe']['result'][$iIncrementalMental]['scriptname'] = $_CONTEXT['thc_pe']['requestedscripts'][$_CONTEXT['thc_pe']['lastscript']];
							$_CONTEXT['thc_pe']['result'][$iIncrementalMental]['starttime'] = microtime(true);
							if($_POST['iMethod']==0){
								// ABABAB
								include($_CONTEXT['thc_pe']['scriptsfolder']."/".$_CONTEXT['thc_pe']['result'][$iIncrementalMental]['scriptname']);
								$_CONTEXT['thc_pe']['lastscript'] = $_CONTEXT['thc_pe']['lastscript']==1 ? 0 : 1;
							}
							else{
								// AAABBB
								include($_CONTEXT['thc_pe']['scriptsfolder']."/".$_CONTEXT['thc_pe']['requestedscripts'][$_CONTEXT['thc_pe']['lastscript']]);
								if($_CONTEXT['thc_pe']['cycles']==($iIncrementalMental+1)){
									$_CONTEXT['thc_pe']['lastscript'] = $_CONTEXT['thc_pe']['lastscript']==1 ? 0 : 1;
								}
							}
							$_CONTEXT['thc_pe']['result'][$iIncrementalMental]['endtime'] = microtime(true);
							$_CONTEXT['thc_pe']['result'][$iIncrementalMental]['time'] = $_CONTEXT['thc_pe']['result'][$iIncrementalMental]['endtime'] - $_CONTEXT['thc_pe']['result'][$iIncrementalMental]['starttime'];
						}
						// calculate average loading time
						$_CONTEXT['thc_pe']['resultavg'] = array();
						// find results with this script name
						for($x=0;$x<$_CONTEXT['thc_pe']['requestedscriptsnumber'];$x++){
							$_CONTEXT['thc_pe']['resultavg'][$x] = array();
							$_CONTEXT['thc_pe']['resultavg'][$x]['name'] = $_CONTEXT['thc_pe']['requestedscripts'][$x];
							$_CONTEXT['thc_pe']['resultavg'][$x]['total'] = 0;
							$_CONTEXT['thc_pe']['resultavg'][$x]['cycles'] = 0;
							for($y=0;$y<count($_CONTEXT['thc_pe']['result']);$y++){
								if($_CONTEXT['thc_pe']['requestedscripts'][$x]==$_CONTEXT['thc_pe']['result'][$y]['scriptname']){
									$_CONTEXT['thc_pe']['resultavg'][$x]['cycles']++;
									$_CONTEXT['thc_pe']['resultavg'][$x]['total'] += $_CONTEXT['thc_pe']['result'][$y]['time'];
								}
							}
							// calculate the average
							$_CONTEXT['thc_pe']['resultavg'][$x]['total'] = round($_CONTEXT['thc_pe']['resultavg'][$x]['total']/$_CONTEXT['thc_pe']['cycles'],7);
						}
						if($_CONTEXT['thc_pe']['report']==1){
							echo Screen("<img src=\"".$_PATHS['root_http']."/graph.php?data=".urlencode(serialize($_CONTEXT['thc_pe']['result']))."&resultavg=".urlencode(serialize($_CONTEXT['thc_pe']['resultavg']))."\" border=\"0\" />",$_CONTEXT['verbose'],$_CONTEXT['silent']);
						}
						else{
							$_CONTEXT['thc_pe']['printresults'] = array();
							$_CONTEXT['thc_pe']['printresults']['time_start'] = date('H:i:s',$_CONTEXT['thc_pe']['startscript']);
							$_CONTEXT['thc_pe']['printresults']['time_end'] = date('H:i:s',time());
							echo Screen("<b>Test started at ".$_CONTEXT['thc_pe']['printresults']['time_start']." and ended at ".$_CONTEXT['thc_pe']['printresults']['time_end']."</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
							for($x=0;$x<count($_CONTEXT['thc_pe']['resultavg']);$x++){
								$_CONTEXT['thc_pe']['printresults']['results'] = array();
								$_CONTEXT['thc_pe']['printresults']['results'][$x] = array();
								$_CONTEXT['thc_pe']['printresults']['results'][$x]['name'] = $_CONTEXT['thc_pe']['resultavg'][$x]['name'];
								$_CONTEXT['thc_pe']['printresults']['results'][$x]['average'] = $_CONTEXT['thc_pe']['resultavg'][$x]['total']/$_CONTEXT['thc_pe']['resultavg'][$x]['cycles'];
								echo Screen("- ".$_CONTEXT['thc_pe']['resultavg'][$x]['name'].": ",$_CONTEXT['verbose'],$_CONTEXT['silent']);
								echo Screen("total time=".$_CONTEXT['thc_pe']['resultavg'][$x]['total']."(s), cycles=".$_CONTEXT['thc_pe']['resultavg'][$x]['cycles'].", ",$_CONTEXT['verbose'],$_CONTEXT['silent']);
								echo Screen("average time=".$_CONTEXT['thc_pe']['printresults']['results'][$x]['average']."<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
							}
							echo Screen("<br />\n<b>Cycles:</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
							for($x=0;$x<count($_CONTEXT['thc_pe']['result']);$x++){
								echo Screen(($x+1)." - ".$_CONTEXT['thc_pe']['result'][$x]['scriptname'].": ".$_CONTEXT['thc_pe']['result'][$x]['time']."<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
							}
							echo Screen("<br />\n<b>Performance:</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
							$dAverageA = $_CONTEXT['thc_pe']['resultavg'][0]['total']/$_CONTEXT['thc_pe']['resultavg'][0]['cycles'];
							$dAverageB = $_CONTEXT['thc_pe']['resultavg'][1]['total']/$_CONTEXT['thc_pe']['resultavg'][1]['cycles'];
							if($dAverageA<$dAverageB){
								$dPercentFaster = number_format((($dAverageB-$dAverageA)/$dAverageA)*100,2);
								$sMessage = $_CONTEXT['thc_pe']['resultavg'][0]['name']." is ".$dPercentFaster."% faster than ".$_CONTEXT['thc_pe']['resultavg'][1]['name'];
							}
							elseif($dAverageA>$dAverageB){
								$dPercentFaster = number_format((($dAverageA-$dAverageB)/$dAverageB)*100,2);
								$sMessage = $_CONTEXT['thc_pe']['resultavg'][1]['name']." is ".$dPercentFaster."% faster than ".$_CONTEXT['thc_pe']['resultavg'][0]['name'];
							}
							else{
								$sMessage = $_CONTEXT['thc_pe']['resultavg'][0]['name']." and ".$_CONTEXT['thc_pe']['resultavg'][1]['name']." are equal in speed";
							}
							echo Screen($sMessage,$_CONTEXT['verbose'],$_CONTEXT['silent']);
						}
						// update entry in background task file
						include($_PATHS['includes_root']."/task_end.php");
					}
					else{
						die(Screen("No such script in this folder",$_CONTEXT['verbose'],$_CONTEXT['silent']));
					}
				}
				else{
					die(Screen("Please select two different scripts to compare",$_CONTEXT['verbose'],$_CONTEXT['silent']));
				}
			}
			else{
				die(Screen("Unexpected amount of scripts selected",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		break;
		/* Create */
		case"Create":
		if(isset($_POST['sScript1']) && isset($_POST['sScript2']) && isset($_POST['sScriptName1']) && isset($_POST['sScriptName2'])){
			if($_POST['sScript1']=="" || $_POST['sScript2']==""){
				die(Screen("Can't save as an empty file",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			if(strlen($_POST['sScript1'])<35 || strlen($_POST['sScript2'])<35){
				die(Screen("Scripts must be at least 35 characters",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			if($_POST['sScriptName1']=="" || $_POST['sScriptName2']==""){
				die(Screen("No script name has been specified for one or more files",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			if(md5($_POST['sScript1'])==md5($_POST['sScript2'])){
				die(Screen("Scripts are exactly the same",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			if($_POST['sScriptName1']==$_POST['sScriptName2']){
				die(Screen("Script names are exactly the same",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			if(!preg_match('/^[a-zA-Z0-9\-_\.]+\.php$/',$_POST['sScriptName1'])){
				die(Screen("Invalid script name for file 1",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			if(!preg_match('/^[a-zA-Z0-9\-_\.]+\.php$/',$_POST['sScriptName2'])){
				die(Screen("Invalid script name for file 2",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			if(in_array($_POST['sScriptName1'],$_CONTEXT['thc_pe']['scripts'])){
				die(Screen("File 1 already exists in destination folder",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			if(in_array($_POST['sScriptName2'],$_CONTEXT['thc_pe']['scripts'])){
				die(Screen("File 2 already exists in destination folder",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			if(!function_exists("WriteF")){
				$sDest = $_PATHS['functions_root']."/fwrite.php";
				include_once($sDest);
			}
			$_CONTEXT['thc_pe']['script1'] = $_CONTEXT['thc_pe']['scriptsfolder']."/".$_POST['sScriptName1'];
			$_CONTEXT['thc_pe']['script2'] = $_CONTEXT['thc_pe']['scriptsfolder']."/".$_POST['sScriptName2'];
			if(!WriteF($_CONTEXT['thc_pe']['script1'],$_POST['sScript1'],"w")){
				die(Screen("File 1 hasn't been saved in destination folder",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			else{
				echo Screen("File 1 has been saved in destination folder<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
			if(!WriteF($_CONTEXT['thc_pe']['script2'],$_POST['sScript2'],"w")){
				die(Screen("File 2 hasn't been saved in destination folder",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			else{
				echo Screen("File 2 has been saved in destination folder<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
		}
		else{
			echo Screen("Unexpected data in form submission",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		break;
		default:
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
?>
