<?php
/* THC Shodown Frontend

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 31-01-2019
*/
if(!defined('IN_SCRIPT')){
	exit;
}
$_CONTEXT['headers'] = (isset($_CONTEXT['headers']) ? $_CONTEXT['headers'] : "")."<script type=\"text/javascript\" src=\"".$_PATHS['module_default_root_http']."/menu.js\"></script>\n";
$_CONTEXT['mfs'] = array();
/* keeps track of the current row when defining properties, which makes it easier to add and remove new rows */
$_CONTEXT['mfs']['currentrow'] = 0;
/* form properties */
$_CONTEXT['mfs']['module'] = $_CONTEXT['module_current'];
/* table */
$_CONTEXT['mfs']['table'] = array();
/* table header */
$_CONTEXT['mfs']['table']['header'] = array();
$_CONTEXT['mfs']['table']['header']['name'] = $_CONTEXT['modules'][$_CONTEXT['mfs']['module']]['name'];
$_CONTEXT['mfs']['table']['header']['description'] = $_CONTEXT['modules'][$_CONTEXT['mfs']['module']]['description'];
/* do we have an api key? */
if(file_exists($_PATHS['module_default_root']."/key.php")){
	include($_PATHS['module_default_root']."/key.php");
}
/* table rows */
if(!isset($_CONTEXT['api']['key']) || $_CONTEXT['api']['key']==""){
	// if we haven't got an api key installed, force to do so
	$_CONTEXT['mfs']['form'] = array();
	$_CONTEXT['mfs']['form']['method'] = "post";
	$_CONTEXT['mfs']['form']['class'] = "apikey";
	$_CONTEXT['mfs']['table']['rows'] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "apik";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "api key";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<input type=\"text\" class=\"feedquery\" name=\"sKeyProvided\" size=\"50\" /><br /><small>You can obtain an api key <a href=\"https://account.shodan.io/register\" target=\"blank\">here</a></small>";
	$_CONTEXT['mfs']['currentrow']++;
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['value'] = "<div class=\"modrowleft mt5\"><input type=\"submit\" name=\"submit\" value=\"Set Key\" /></div>";
}
else{
	// set options
	$sSelect = "\n						<select name=\"sMethod\" class=\"method\">\n";
	$sSelect .= "							<option value=\"-1\" selected>select an option</option>\n";
	$sSelect .= "							<option value=\"1\">regular search</option>\n";
	$sSelect .= "							<option value=\"3\">host search</option>\n";
	$sSelect .= "							<option value=\"5\">ip search</option>\n";
	$sSelect .= "							<option value=\"8\">honeypot detection</option>\n";
	$sSelect .= "							<option value=\"10\">ports crawled</option>\n";
	$sSelect .= "							<option value=\"11\">protocols available</option>\n";
	$sSelect .= "							<option value=\"12\">load previous queries</option>\n";
	$sSelect .= "						</select>\n";
	/* form properties */
	$_CONTEXT['mfs']['module'] = $_CONTEXT['module_current'];
	$_CONTEXT['mfs']['form'] = array();
	$_CONTEXT['mfs']['form']['method'] = "post";
	$_CONTEXT['mfs']['form']['class'] = "shodan";
	$_CONTEXT['mfs']['table']['rows'] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "selectmenu";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "action";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $sSelect;
	$_CONTEXT['mfs']['currentrow']++;
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['id'] = "queryfields";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['id'] = "queryfields";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<i>make a selection first</i>";
	$_CONTEXT['mfs']['currentrow']++;
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "hidemod";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "save results";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<input type=\"checkbox\" id=\"checkme\" name=\"iSave\" value=\"1\" />";
	$_CONTEXT['mfs']['currentrow']++;
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
	$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['value'] = "<div class=\"modrowleft mt5\"><input type=\"submit\" name=\"submit\" value=\"Send\" /> <input type=\"submit\" name=\"submit\" class=\"shower\" value=\"Show Raw\" /> <input type=\"submit\" name=\"submit\" class=\"deleter\" value=\"Delete\" /></div>";
}
// create output form
$sCode = ModForm($_CONTEXT['mfs']);
?>