<?php
/*
Reads previous scan results

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 15-02-2019
*/
set_time_limit(0);
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "../..";
include_once("../../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
// scan_data.php
$sFile = "scan_data.php";
if(!file_exists($sFile)){
	$aDataR['jmessage'] = "Scan result file doesn't exist";
}
else{
	// get scan result files and put them in a select menu
	include($sFile);
	if(!isset($_CONTEXT['scan_results'][0])){
		$aDataR['jmessage'] = "No scan results found";
	}
	else{
		$aDataR['jmessage'] = "<select name=\"sScanResults\" class=\"fileresults\">";
		for($x=0;$x<count($_CONTEXT['scan_results']);$x++){
			$aDataR['jmessage'] .= "<option value=\"".$_CONTEXT['scan_results'][$x]['filename']."\">".$_CONTEXT['scan_results'][$x]['filename']."</option>";
		}
		$aDataR['jmessage'] .= "</select>";
		$aDataR['jresult'] = true;
	}
}
echo json_encode($aDataR);
?>