<?php
/* Scans a host for open ports

ModGlue Variables:
$_CONTEXT['thc_xs']['datafile']
$_CONTEXT['thc_xs']['data_template']
$_CONTEXT['thc_xs']['scan_results']
$_CONTEXT['thc_xs']['queries']
$_CONTEXT['thc_xs']['update']
$_CONTEXT['thc_xs']['countnumber']
$_CONTEXT['thc_xs']['scanresultfile']
$_CONTEXT['thc_xs']['validfile']
$_CONTEXT['thc_xs']['scan_properties']['ports']
$_CONTEXT['thc_xs']['scan_properties']['domain']
$_CONTEXT['thc_xs']['scan_properties']['protocol']
$_CONTEXT['thc_xs']['scan_properties']['host']
$_CONTEXT['thc_xs']['scan_properties']['time']
$_CONTEXT['thc_xs']['hosts']
$_CONTEXT['thc_xs']['socket']
$_CONTEXT['thc_xs']['scan_hosts']
$_CONTEXT['thc_xs']['valid']
$_CONTEXT['thc_xs']['socket']['protocol_type']
$_CONTEXT['thc_xs']['scan_hosts_count']
$_CONTEXT['thc_xs']['ports']
$_CONTEXT['thc_xs']['scan']
$_CONTEXT['thc_xs']['scan']['min']
$_CONTEXT['thc_xs']['scan']['max']
$_CONTEXT['thc_xs']['portoptions']
$_CONTEXT['thc_xs']['data_template_new']
$_CONTEXT['thc_xs']['current_host']
$_CONTEXT['thc_xs']['socket_create']
$_CONTEXT['thc_xs']['open']
$_CONTEXT['thc_xs']['open_ports']
$_CONTEXT['thc_xs']['port']
$_CONTEXT['thc_xs']['socket_connect']
$_CONTEXT['thc_xs']['filename']
$_CONTEXT['thc_xs']['fullfilename']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 19-05-2024
*/
// set variable to be able to save a task
$_MODULE_C = "thc_xs";
include_once("../../Includes/screen_header.php");
$_CONTEXT['thc_xs'] = array();
$_CONTEXT['thc_xs']['datafile'] = $_PATHS['module_default_root']."/scan_data.php";
include_once($_PATHS['module_default_root']."/ports.php");
include_once($_PATHS['module_default_root']."/sockets.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
// sockets are required for this
if(!function_exists("socket_create")){
	die($sOut."This module requires sockets to be enabled. You can open your php.ini file and uncomment the socket extension(remove semicolon), save and restart your server.");
}
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// enter portscan in task list
		case"Scan":
		include($_PATHS['includes_root']."/task_start.php");
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		break;
		// remove file
		case"Remove File":
		@include($_CONTEXT['thc_xs']['datafile']);
		include_once($_PATHS['functions_root']."/fwrite.php");
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		// set template for scan data
		$_CONTEXT['thc_xs']['data_template'] = "<?php\n/* Scan results for THC_XS\n\nAuthor: Remco Kouw\nSite: http://www.hacksuite.com\nLast Edit: ".date($_CONTEXT['time_pattern'],time())."\n*/\nif(!defined('IN_SCRIPT')){\n\texit;\n}\n\$_CONTEXT['thc_xs']['scan_results'] = array();\n";
		$_CONTEXT['thc_xs']['queries'] = @count($_CONTEXT['thc_xs']['scan_results']);
		$_CONTEXT['thc_xs']['update'] = false;
		$_CONTEXT['thc_xs']['countnumber'] = 0;
		if($_CONTEXT['thc_xs']['queries']!=0){
			// add old records
			for($x=0;$x<$_CONTEXT['thc_xs']['queries'];$x++){
				if($_CONTEXT['thc_xs']['scan_results'][$x]['filename']==$_POST['sScanResults']){
					$_CONTEXT['thc_xs']['update'] = true;
					continue;
				}
				$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['countnumber']."] = array();\n";
				$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['countnumber']."]['domain'] = \"".$_CONTEXT['thc_xs']['scan_results'][$x]['domain']."\";\n";
				$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['countnumber']."]['host'] = \"".$_CONTEXT['thc_xs']['scan_results'][$x]['host']."\";\n";
				$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['countnumber']."]['protocol'] = \"".$_CONTEXT['thc_xs']['scan_results'][$x]['protocol']."\";\n";
				$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['countnumber']."]['time'] = \"".$_CONTEXT['thc_xs']['scan_results'][$x]['time']."\";\n";
				$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['countnumber']."]['filename'] = \"".$_CONTEXT['thc_xs']['scan_results'][$x]['filename']."\";\n";
				$_CONTEXT['thc_xs']['countnumber']++;
			}
		}
		else{
			die(Screen("No records present in <b>".$_CONTEXT['thc_xs']['datafile']."</b>",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		if($_CONTEXT['thc_xs']['update']){
			$_CONTEXT['thc_xs']['scanresultfile'] = $_PATHS['module_default_root']."/results/".$_POST['sScanResults'];
			@unlink($_CONTEXT['thc_xs']['scanresultfile']);
			if(!WriteF($_CONTEXT['thc_xs']['datafile'],$_CONTEXT['thc_xs']['data_template']."?>","w")){
				die(Screen("Failed to update scan data file",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			else{
				die(Screen("Successfully removed file properties",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		else{
			die(Screen("Specified file properties don't exist",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		exit;
		break;
		// dump of open ports on hosts
		case"View File":
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		@include($_CONTEXT['thc_xs']['datafile']);
		if(!isset($_CONTEXT['thc_xs']['scan_results'][0])){
			die(Screen("No records found in <b>".$_CONTEXT['thc_xs']['datafile']."</b>",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		$_CONTEXT['thc_xs']['validfile'] = false;
		$_CONTEXT['thc_xs']['scan_properties'] = array();
		for($x=0;$x<count($_CONTEXT['thc_xs']['scan_results']);$x++){
			// get scan properties
			if($_CONTEXT['thc_xs']['scan_results'][$x]['filename']==$_POST['sScanResults']){
				$_CONTEXT['thc_xs']['validfile'] = true;
				$_CONTEXT['thc_xs']['scan_properties'] = $_CONTEXT['thc_xs']['scan_results'][$x];
				$_CONTEXT['thc_xs']['scan_properties']['ports'] = json_decode(file_get_contents($_PATHS['module_default_root']."/results/".$_POST['sScanResults']),true);
				break;
			}
		}
		if($_CONTEXT['thc_xs']['validfile']){
			// dump scan properties
		 	echo"<table border=\"0\" cellspacing=\"3\" cellpadding=\"3\">\n";
		 	echo"<tr><th>type</th><th>protocol</th><th>host</th><th>ports open</th><th>time</th></tr>\n";
			echo"<tr><td>".$_CONTEXT['thc_xs']['scan_properties']['domain']."</td><td>".$_CONTEXT['thc_xs']['scan_properties']['protocol']."</td><td>".$_CONTEXT['thc_xs']['scan_properties']['host']."</td><td>".implode(", ",$_CONTEXT['thc_xs']['scan_properties']['ports'])."</td><td>".date($_CONTEXT['time_pattern'].' H:i:s',$_CONTEXT['thc_xs']['scan_properties']['time'])."</td></tr>\n";
		 	echo"</table>\n";
		}
		else{
			die(Screen("No properties found for the specified file",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		exit;
		break;
		// just show index
		default:
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// do some rough validation and fall through till we start the scanning
if(isset($_POST['sInput']) && $_POST['sInput']!=""){
	$_CONTEXT['thc_xs']['hosts'] = @explode(",",$_POST['sInput']);
}
else{
	die(Screen("No hostname specified.",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
if(!isset($_CONTEXT['thc_xs']['socket'][$_POST['sScan']])){
	die(Screen("Invalid value for scan.",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
$_CONTEXT['thc_xs']['scan_hosts'] = array();
$_CONTEXT['thc_xs']['valid'] = 0;
for($x=0;$x<count($_CONTEXT['thc_xs']['hosts']);$x++){
	// support for ipv4 and ipv6 addresses scans
	if(@filter_var($_CONTEXT['thc_xs']['hosts'][$x],FILTER_VALIDATE_IP,FILTER_FLAG_IPV4)){
		$_CONTEXT['thc_xs']['scan_hosts'][$_CONTEXT['thc_xs']['valid']] = array();
		$_CONTEXT['thc_xs']['scan_hosts'][$_CONTEXT['thc_xs']['valid']]['domain'] = $_CONTEXT['thc_xs']['socket']['protocol_type'][0];
	}
	elseif(@filter_var($_CONTEXT['thc_xs']['hosts'][$x],FILTER_VALIDATE_IP,FILTER_FLAG_IPV6)){
		$_CONTEXT['thc_xs']['scan_hosts'][$_CONTEXT['thc_xs']['valid']] = array();
		$_CONTEXT['thc_xs']['scan_hosts'][$_CONTEXT['thc_xs']['valid']]['domain'] = $_CONTEXT['thc_xs']['socket']['protocol_type'][1];
	}
	else{
		continue;
	}
	$_CONTEXT['thc_xs']['scan_hosts'][$_CONTEXT['thc_xs']['valid']]['host'] = $_CONTEXT['thc_xs']['hosts'][$x];
	$_CONTEXT['thc_xs']['scan_hosts'][$_CONTEXT['thc_xs']['valid']]['type'] = $_CONTEXT['thc_xs']['socket'][$_POST['sScan']][0];
	$_CONTEXT['thc_xs']['scan_hosts'][$_CONTEXT['thc_xs']['valid']]['protocol'] = $_CONTEXT['thc_xs']['socket'][$_POST['sScan']][1];
	$_CONTEXT['thc_xs']['valid']++;
}
if(false==($_CONTEXT['thc_xs']['scan_hosts_count'] = @count($_CONTEXT['thc_xs']['scan_hosts']))){
	die(Screen("No valid hosts specified.",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
$_CONTEXT['thc_xs']['ports'] = array();
$_CONTEXT['thc_xs']['scan'] = array();
$_CONTEXT['thc_xs']['scan']['min'] = 0;
$_CONTEXT['thc_xs']['scan']['max'] = 0;
if(isset($_POST['sManualPorts'])){
 	if($_POST['sManualPorts']!=""){
 	 	if(strpos($_POST['sManualPorts'],",")>0){
	 		$_CONTEXT['thc_xs']['ports'] = @explode(",",$_POST['sManualPorts']);
	 		$_CONTEXT['thc_xs']['scan']['max'] = count($_CONTEXT['thc_xs']['ports']);
	 		for($x=0;$x<$_CONTEXT['thc_xs']['scan']['max'];$x++){
	 			$_CONTEXT['thc_xs']['ports'][$x] = intval(trim($_CONTEXT['thc_xs']['ports'][$x]));
	 		}
 		}
 	}
}
else{
	if(!isset($_CONTEXT['thc_xs']['portoptions'][$_POST['sType']])){
	 	// if it's invalid we'll just scan 1-1024
		$_POST['sType'] = "registered";
	}
	$_CONTEXT['thc_xs']['scan']['min'] = $_CONTEXT['thc_xs']['portoptions'][$_POST['sType']][0];
	$_CONTEXT['thc_xs']['scan']['max'] = $_CONTEXT['thc_xs']['portoptions'][$_POST['sType']][1] - $_CONTEXT['thc_xs']['portoptions'][$_POST['sType']][0];
}
// catch invalid setup
if($_CONTEXT['thc_xs']['scan']['min']==$_CONTEXT['thc_xs']['scan']['max']){
 	die(Screen("Invalid scan options specified, remember that if you use manual ports that you need <b>,</b> in order to separate values.",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
echo Screen("<br />\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// spit fire...
flush();
ob_flush();
// let's scan the target
include_once($_PATHS['functions_root']."/fwrite.php");
$_CONTEXT['thc_xs']['data_template_new'] = "";
// previous scan data
@include($_CONTEXT['thc_xs']['datafile']);
$_CONTEXT['thc_xs']['current_host'] = isset($_CONTEXT['thc_xs']['scan_results']) ? @count($_CONTEXT['thc_xs']['scan_results']) : 0;
// every host
for($y=0;$y<$_CONTEXT['thc_xs']['scan_hosts_count'];$y++){
	if(false!==($_CONTEXT['thc_xs']['socket_create'] = @socket_create(constant($_CONTEXT['thc_xs']['scan_hosts'][$y]['domain']),constant($_CONTEXT['thc_xs']['scan_hosts'][$y]['type']),constant($_CONTEXT['thc_xs']['scan_hosts'][$y]['protocol'])))){
		$_CONTEXT['thc_xs']['open'] = 0;
		$_CONTEXT['thc_xs']['open_ports'] = array();
		// every port
		for($x=$_CONTEXT['thc_xs']['scan']['min'];$x<$_CONTEXT['thc_xs']['scan']['max'];$x++){
			// try to connect to port
			$_CONTEXT['thc_xs']['port'] = isset($_POST['sManualPorts']) ? $_CONTEXT['thc_xs']['ports'][$x] : $x;
			$_CONTEXT['thc_xs']['socket_connect'] = @socket_connect($_CONTEXT['thc_xs']['socket_create'],$_CONTEXT['thc_xs']['scan_hosts'][$y]['host'],$_CONTEXT['thc_xs']['port']);
			if($_CONTEXT['thc_xs']['socket_connect']){
				$_CONTEXT['thc_xs']['open']++;
				$_CONTEXT['thc_xs']['open_ports'][] = $_CONTEXT['thc_xs']['port'];
				// terminate socket
				socket_close($_CONTEXT['thc_xs']['socket_create']);
				// create new socket
				$_CONTEXT['thc_xs']['socket_create'] = @socket_create(constant($_CONTEXT['thc_xs']['scan_hosts'][$y]['domain']),constant($_CONTEXT['thc_xs']['scan_hosts'][$y]['type']),constant($_CONTEXT['thc_xs']['scan_hosts'][$y]['protocol']));
				echo Screen("[".$_CONTEXT['thc_xs']['scan_hosts'][$y]['host'].":".$_CONTEXT['thc_xs']['port']."] - <b>OPEN</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
			else{
				echo Screen("[".$_CONTEXT['thc_xs']['scan_hosts'][$y]['host'].":".$_CONTEXT['thc_xs']['port']."] - <b>CLOSED</b> - (".socket_strerror(socket_last_error()).")<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
			// send to browser
			flush();
			ob_flush();
		}
		$_CONTEXT['thc_xs']['filename'] = time()."-".substr(md5(mt_rand(0,1000)),0,mt_rand(5,9)).".php";
		$_CONTEXT['thc_xs']['fullfilename'] = $_PATHS['module_default_root']."/results/".$_CONTEXT['thc_xs']['filename'];
		if(!WriteF($_CONTEXT['thc_xs']['fullfilename'],json_encode($_CONTEXT['thc_xs']['open_ports']),"w")){
			echo Screen("<p>Failed to write open port numbers to <b>results/".$_CONTEXT['thc_xs']['filename']."</b></p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		else{
			// if file was successfully created, make a new template
			$_CONTEXT['thc_xs']['data_template_new'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['current_host']."] = array();\n";
			$_CONTEXT['thc_xs']['data_template_new'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['current_host']."]['domain'] = \"".($_CONTEXT['thc_xs']['scan_hosts'][$y]['domain']=="AF_INET6" ? "ipv6" : "ipv4")."\";\n";
			$_CONTEXT['thc_xs']['data_template_new'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['current_host']."]['host'] = \"".$_CONTEXT['thc_xs']['scan_hosts'][$y]['host']."\";\n";
			$_CONTEXT['thc_xs']['data_template_new'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['current_host']."]['protocol'] = \"".($_CONTEXT['thc_xs']['scan_hosts'][$y]['protocol']=="SOL_TCP" ? "tcp" : "udp")."\";\n";
			$_CONTEXT['thc_xs']['data_template_new'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['current_host']."]['time'] = \"".$_CONTEXT['start_task']."\";\n";
			$_CONTEXT['thc_xs']['data_template_new'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$_CONTEXT['thc_xs']['current_host']."]['filename'] = \"".$_CONTEXT['thc_xs']['filename']."\";\n";
			$_CONTEXT['thc_xs']['current_host']++;
		}
		echo Screen("</p><p><b>open ports for ".$_CONTEXT['thc_xs']['scan_hosts'][$y]['host']."</b>: ".$_CONTEXT['thc_xs']['open']." (running time) ".(time()-$_CONTEXT['start_task'])."(s)</p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
	
	}
	else{
		echo Screen("Failed to create socket",$_CONTEXT['verbose'],$_CONTEXT['silent']);
	}
}
// set template for scan data
$_CONTEXT['thc_xs']['data_template'] = "<?php\n/* Scan results for THC_XS\n\nAuthor: Remco Kouw\nSite: http://www.hacksuite.com\nLast Edit: ".date($_CONTEXT['time_pattern'],time())."\n*/\nif(!defined('IN_SCRIPT')){\n\texit;\n}\n\$_CONTEXT['thc_xs']['scan_results'] = array();\n";
$_CONTEXT['thc_xs']['queries'] = @count($_CONTEXT['thc_xs']['scan_results']);
if($_CONTEXT['thc_xs']['queries']!=0){
	// add old records
	for($x=0;$x<$_CONTEXT['thc_xs']['queries'];$x++){
		$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$x."] = array();\n";
		$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$x."]['domain'] = \"".$_CONTEXT['thc_xs']['scan_results'][$x]['domain']."\";\n";
		$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$x."]['host'] = \"".$_CONTEXT['thc_xs']['scan_results'][$x]['host']."\";\n";
		$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$x."]['protocol'] = \"".$_CONTEXT['thc_xs']['scan_results'][$x]['protocol']."\";\n";
		$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$x."]['time'] = \"".$_CONTEXT['thc_xs']['scan_results'][$x]['time']."\";\n";
		$_CONTEXT['thc_xs']['data_template'] .= "\$_CONTEXT['thc_xs']['scan_results'][".$x."]['filename'] = \"".$_CONTEXT['thc_xs']['scan_results'][$x]['filename']."\";\n";
	}
}
if(!WriteF($_CONTEXT['thc_xs']['datafile'],$_CONTEXT['thc_xs']['data_template'].$_CONTEXT['thc_xs']['data_template_new']."?>","w")){
	echo Screen("<p>Failed to update scan data file, this basically means that there are files not linked to ".$_CONTEXT['thc_xs']['datafile']."</p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
// update entry in background task file
include($_PATHS['includes_root']."/task_end.php");
echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>
