<?php
/* Manager for dorks and SQL errors

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 31-08-2023
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if(defined('SPIDER')){
	$_CONTEXT['nativekeywords'][8] = array("native","dorks","sql","edit","editor");
}
else{
	$_CONTEXT['subtitle'] = "Dork Manager";
	// make selection menu for dorks and sql errors automatically
	$_CONTEXT['makeselect'] = 1;
	// target files we need, so make sure they are present
	$aFiles = array($_PATHS['functions_root']."/fwrite.php",$_PATHS['data_root']."/dork_options.php",$_PATHS['includes_root']."/dorkssqlhandler.php");
	for($x=0;$x<count($aFiles);$x++){
		(!IsThere($aFiles[$x]) ? include_once($_PATHS['end']) : include_once($aFiles[$x]));
	}
	$sJSDev = "<script type=\"text/javascript\" src=\"Templates/".$_PATHS['style_user']."/js/dorks.js\"></script>\n";
	$_CONTEXT['headers'] = isset($_CONTEXT['headers']) ? $_CONTEXT['headers'].$sJSDev : $sJSDev;
	$_OPTDORK = array(1,3);
	if(isset($_CONTEXT['dselect'])){
		// there are google dorks available
		$_OPTDORK[] = 0;
	}
	if(isset($_CONTEXT['sselect'])){
		// there are sql errors available
		$_OPTDORK[] = 2;
	}
	// select menu for options
	$sSelect = "\n		<select name=\"sSelectItem\" class=\"selectitem\">\n";
	$sSelect .= "			<option value=\"-1\">select an option</option>\n";
	// create selection menu
	for($x=0;$x<count($_OPTDORK);$x++){
		$sSelect .= "			<option value=\"".$_CONTEXT['doptions'][$_OPTDORK[$x]]['submit']."\">".$_CONTEXT['doptions'][$_OPTDORK[$x]]['label']."</option>\n";
	}
	$sSelect .= "		</select>\n";
	// main form will always be displayed
	$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Dork and SQL Manager</div>\n";
	$sCode .= "				<div class=\"cc_record\">\n";
	$sCode .= "					<div class=\"flt pad3 w150\">select action</div>\n";
	$sCode .= "					<div class=\"flt pad3\"><form method=\"post\" class=\"staticform\"></form></div>\n";
	$sCode .= "				</div>\n";
	// dynamic form will be automatically generated
	$sCode .= "				<form method=\"post\" class=\"dynamicform\"></form>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "			</div>\n";
}
?>