<?php
/* Maintenance scan configuration

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 31-08-2023
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if(defined('SPIDER')){
	$_CONTEXT['nativekeywords'][20] = array("native","maintenance","scan","scanner","scanning","scans");
}
else{
	$_CONTEXT['subtitle'] = "Maintenance Scanner";
	$sJSDev = "<script type=\"text/javascript\" src=\"Templates/".$_PATHS['style_user']."/js/maintenance_scan.js\"></script>\n";
	$_CONTEXT['headers'] = isset($_CONTEXT['headers']) ? $_CONTEXT['headers'].$sJSDev : $sJSDev;
	// target files we need, so make sure they are present
	$aFiles = array($_PATHS['functions_root']."/fwrite.php",$_PATHS['functions_root']."/get_file_data.php");
	for($x=0;$x<count($aFiles);$x++){
		(!IsThere($aFiles[$x]) ? include_once($_PATHS['end']) : include_once($aFiles[$x]));
	}
	// output form
	$sSelect = "\n<select name=\"iUpdateMe\" class=\"updateme\">\n";
	$sSelect .= "	<option value=\"-1\" selected=\"selected\">select an option</option>\n";
	$sSelect .= "	<option value=\"0\">enable or disable maintenance scans</option>\n";
	$sSelect .= "	<option value=\"1\">filesize scan</option>\n";
	$sSelect .= "	<option value=\"2\">maximum filesize of data files in KB</option>\n";
	$sSelect .= "	<option value=\"3\">analyzes logfiles</option>\n";
	$sSelect .= "	<option value=\"4\">checks if all required functions are there</option>\n";
	$sSelect .= "	<option value=\"5\">count the files in specific folders</option>\n";
	$sSelect .= "	<option value=\"6\">maximum files in dir before reporting</option>\n";
	$sSelect .= "	<option value=\"7\">global interval between a maintenance scan</option>\n";
	$sSelect .= "	<option value=\"8\">check for outdated apps and modules</option>\n";
	$sSelect .= "	<option value=\"9\">spider keywords in files</option>\n";
	$sSelect .= "</select>\n";
	// store default values
	$sHidden = "<div class=\"defvals\">\n";
	$sHidden .= "	<div class=\"allow_maintenance_scan\">".$_CONTEXT['allow_maintenance_scan']."</div>\n";
	$sHidden .= "	<div class=\"allow_filesizescan\">".$_CONTEXT['allow_filesizescan']."</div>\n";
	$sHidden .= "	<div class=\"maxflsz\">".$_CONTEXT['maxflsz']."</div>\n";
	$sHidden .= "	<div class=\"allow_logfileanalyze\">".$_CONTEXT['allow_logfileanalyze']."</div>\n";
	$sHidden .= "	<div class=\"allow_functcheck\">".$_CONTEXT['allow_functcheck']."</div>\n";
	$sHidden .= "	<div class=\"allow_filesindirscan\">".$_CONTEXT['allow_filesindirscan']."</div>\n";
	$sHidden .= "	<div class=\"maxflsindir\">".$_CONTEXT['maxflsindir']."</div>\n";
	$sHidden .= "	<div class=\"nextscanseconds\">".$_CONTEXT['nextscanseconds']."</div>\n";
	$sHidden .= "	<div class=\"allow_version_check\">".$_CONTEXT['allow_version_check']."</div>\n";
	$sHidden .= "	<div class=\"keywords_spider\">".$_CONTEXT['allow_version_check']."</div>\n";
	$sHidden .= "</div>\n";
	// form
	$sCode .= "			<form method=\"post\" class=\"security\">\n";
	$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Configure scanner settings</div>\n";
	$sCode .= "				<div class=\"cc_record\">\n";
	$sCode .= "					<div class=\"flt pad3 w150\">select option</div>\n";
	$sCode .= "					<div class=\"flt pad3\">".$sSelect."</div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "				<div class=\"dholder\"></div>\n";
	$sCode .= "				<div class=\"cc_record\">\n";
	$sCode .= "					<div class=\"flt pad3\"><input type=\"submit\" name=\"submit\" value=\"Update\" /><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\" /></div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "			</div>\n";
	$sCode .= "			</form>\n";
	$sCode .= $sHidden;
}
?>