/* Handles screen file setup */
$(document).ready(function(){
	$(".cc_record#mem").hide();
	$(".cc_record#tim").hide();
	$("input.findbutton").hide();
});
$(document).on("change","select.setuptype",function(){
	if($(this).val()=='-1'){
		// invalid
		$(".cc_record#mem").hide();
		$(".cc_record#tim").hide();
	}
	else if($(this).val()=='1'){
		// memory
		$(".cc_record#mem").show();
		$(".cc_record#tim").hide();
	}
	else if($(this).val()=='2'){
		// execution time
		$(".cc_record#mem").hide();
		$(".cc_record#tim").show();
	}
});
$(document).on("change","select.modname",function(){
	if($(this).val()!='-1'){
		$("input.findbutton").show();
	}
	else{
		$("input.findbutton").hide();
	}
});
$(document).on("click","input.submitbutton",function(e){
	e.preventDefault();
	dataString = $("form.setscreen").serialize();
	$.ajax({
		type: "POST",
		url: "JSON/screensetup.php",
		data: "submitbutton="+$(this).val()+"&"+dataString,
		dataType: "json",
		success: function(json){
			alert(json.jmessage);
		}
	});
});