$(document).ready(function(){
	$('ul#searchresults').hide();
	dataString = $("form.searchquery").serialize();
	$(".searchterm").on("input",function(){
		var query = $(this).val();
		if(query.length>=3){
			$('ul#searchresults').show();
			$.ajax({
				type: "POST",
				url: "JSON/search.php",
                data: "sSearch="+$(this).val(),
                dataType: "json",
                success: function (json){
					if(json.jtotal>0){
						var $resultsList = $("ul#searchresults");
						$resultsList.empty();
						var nativeArray = json.jsearch.native;
						var modulesArray = json.jsearch.modules;
						var appsArray = json.jsearch.apps;
						$.each(nativeArray,function(index,item){
							var number = item[0];
							var type = item[1];
							var description = item[2];
							$("ul#searchresults").append("<li><a href=\"#\" class=\"wrapcfg\" id="+number+">"+description+"</a></li>");
						});
						$.each(modulesArray,function(index,item){
							var code = item[0];
							var name = item[1];
							var description = item[2];
							var keyword = item[3];
							$("ul#searchresults").append("<li><a href=\"index.php?module="+code+"\">"+name+"</a>: "+description+"</li>");
						});
						$.each(appsArray,function(index,item){
							var code = item[0];
							var name = item[1];
							var description = item[2];
							var keyword = item[3];
							$("ul#searchresults").append("<li><a href=\"Apps/"+code+"\">"+name+"</a>: "+description+"</li>");
						});
					}
					else if(json.jresult){
						$("ul#searchresults").append("<li>no relevant applications found, please try to use different keywords</li>");
					}
					else{
						alert(json.jmessage);
					}
				}
			});
		}
		else{
			$('ul#searchresults').empty();
			$('ul#searchresults').hide();
		}
	});
});