/* All js for setup

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 04-04-2019
*/
// hides all elements when document is loaded
$(document).ready(function(){
	$('.row#iprow').hide();
	$('.row#passrow').hide();
	$('.row#submitrow').hide();
});
// sends form and handles the response from the installation script
$(document).on("submit","form.install",function(e){
	e.preventDefault();
	dataString = $("form.install").serialize();
	$.ajax({
		type: "POST",
		url: "JSON/setup.php",
		data: dataString,
		dataType: "json",
		beforeSend:function() {
			$('input.hitme').hide('slow');
		},
		success: function(json){
			if(json.jresult==false){
				if(json.jallow=="1"){
					$('form.install').append('<input type="hidden" name="iConfirm" value="1" />');
				}
				$('input.hitme').show('slow');
				alert(json.jmessage);
			}
			else{
				alert('Successfully secured your environment, redirecting to index');
				document.location.href = 'index.php';
			}
		}
	});
});
// creates form elements
$(document).on("change","select.installtype",function(e){
	$('.row#iprow').hide();
	$('.row#passrow').hide();
	$('.row#submitrow').hide();
	if($(this).val()=="1"){
		// password
		$('.row#passrow').show();
		$('.row#submitrow').show();
	}
	else if($(this).val()=="2"){
		// ip address
		$('.row#iprow').show();
		$('.row#submitrow').show();
	}
	else if($(this).val()=="3"){
		// password and ip address
		$('.row#iprow').show();
		$('.row#passrow').show();
		$('.row#submitrow').show();
	}
	else{
		// invalid value
		alert('Invalid value for installation type');
	}
});