<?php
/* environment */
include_once("header.php");
$_CONTEXT['page_title'] = "Carnivore CMS: Environment";
$_CONTEXT['subtitle'] = "Carnivore Environment";
if(defined('SPIDER')){
	$_CONTEXT['nativekeywords'][17] = array("native","appearance","style","enable","disable");
}
else{
	$sCode = "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Module Settings</div>\n";
	$sCode .= "				<div class=\"cc_record overflw borderr5 mt5\">\n";
	$sCode .= "					<div class=\"flt pad3\">\n";
	$aModules = get_loaded_extensions();
	foreach($aModules as $sModule){
		if(extension_loaded($sModule)){
			$sCode .= "<b id=sux>".$sModule." is loaded</b><br />\n";
			$sCode .= "<blockquote>\n";
			if(false!==($aFunctions = get_extension_funcs($sModule))){
				foreach($aFunctions as $sFunction){
					$sCode .= "<a href=\"https://www.php.net/manual/en/function.".str_replace("_","-",$sFunction).".php\" target=\"_blank\">".$sFunction."</a><br />\n";
				}
			}
			else{
				$sCode .= "no functions present<br />\n";
			}
			$sCode .= "</blockquote>\n";
		}
		else{
			$sCode .= "<b id=ror>".$sModule." is not loaded</b><br />\n";
		}
	}
	$sCode .= "					</div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "			</div>\n";
	$sCode .= "			<div class=\"clear\"></div>\n";
	$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Included Files</div>\n";
	$sCode .= "				<div class=\"cc_record overflw borderr5 mt5\">\n";
	$sCode .= "					<div class=\"flt pad3\">\n";
	$aIncluded = get_included_files();
	for($x=0;$x<count($aIncluded);$x++){
		$sCode .= "			".$aIncluded[$x]."<br />\n";
	}
	$sCode .= "					</div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "			</div>\n";
	$sCode .= "			<div class=\"clear\"></div>\n";
	$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Defined Constants</div>\n";
	$sCode .= "				<div class=\"cc_record overflw borderr5 mt5\">\n";
	$sCode .= "					<div class=\"flt pad3\">\n";
	$aConstants = get_defined_constants(true);
	foreach($aConstants as $sKey=>$aValues){
		$sCode .= "						<b id=sux>".$sKey."</b><br />\n";
		$sCode .= "						<blockquote>\n";
		foreach($aValues as $sConstant=>$mValue){
			$sCode .= "							".$sConstant."=>".$mValue."<br />\n";
		}
		$sCode .= "						</blockquote>\n";
	}
	$sCode .= "					</div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "			</div>\n";
	$sCode .= "			<div class=\"clear\"></div>\n";
	$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Resources</div>\n";
	$sCode .= "				<div class=\"cc_record overflw borderr5 mt5\">\n";
	$sCode .= "					<div class=\"flt pad3\">\n";
	$aResources = get_resources();
	$sCode .= "						<b id=sux>resources</b><br />\n";
	$sCode .= "						<blockquote>\n";
	foreach($aResources as $sKey=>$sValue){
		$sCode .= "							".$sKey."=>".$sValue."<br />\n";
	}
	$sCode .= "						</blockquote>\n";
	$sCode .= "					</div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "			</div>\n";
	$sCode .= "			<div class=\"clear\"></div>\n";
	$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Current User</div>\n";
	$sCode .= "				<div class=\"cc_record overflw borderr5 mt5\">\n";
	$sCode .= "					<div class=\"flt pad3\">\n";
	$sCode .= "						<b id=sux>User</b><br />\n";
	$sCode .= "						<blockquote>\n";
	$sCode .= "							".get_current_user();
	$sCode .= "						</blockquote>\n";
	$sCode .= "					</div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "			</div>\n";
}
include_once($_PATHS['style_root']."/index.php");
?>