<?php
/*
Scans for files in modules

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 28-06-2023
*/
function ScanFolder($sPath){
	$oPath = new DirectoryIterator($sPath);
	$aFolders = array();
	foreach($oPath as $oFile){
		if(!$oFile->isDot() && $oFile->isDir()){
			$sFolder = $oFile->getFilename();
			if(preg_match('/^thc_[a-zA-Z]{2}$/',$sFolder)){
				$sSubPath = $oFile->getPathname();
				$aFiles = GatherFiles($sSubPath);
				$aFolders[$sFolder] = $aFiles;
			}
		}
	}
	return $aFolders;
}
function GatherFiles($sPath){
	$oPath = new DirectoryIterator($sPath);
	$aFiles = array();
	foreach($oPath as $oFile){
		if($oFile->isFile()){
			if($oFile->getExtension()!="png"){
				$aFiles[] = $oFile->getFilename();
			}
		}
	}
	return $aFiles;
}
?>