<?php
/* Class with MyBB 1.8 specific methods

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 26-03-2019
*/
if(!defined('IN_SCRIPT')){
	exit;
}
class ProductSpecific extends GenContent {
	// checks if a user exists
	function UserExists($sUser){
		$sQuery = "SELECT username FROM ".$this->GetPrefix().$this->GetTable()." WHERE username='".$sUser."'";
		$rQuery = mysqli_query($this->GetConnect(),$sQuery);
		return(mysqli_num_rows($rQuery));
	}
	// method how passwords are hashed
	function PassHashing($sSalt,$sPass){
		return(md5(md5($sSalt).md5($sPass)));
	}
	// set account settings for user table, only used when creating new accounts for product
	function SetAccountSettings($aQuery){
		$iTime = time();
		$aQuery['username'] = $this->MakeUser();
		$aQuery['salt'] = $this->RandomString(8);
		$aQuery['password'] = $this->PassHashing($aQuery['salt'],$this->sPass);
		$aQuery['loginkey'] = $this->RandomString(50);
		$aQuery['email'] = $this->sEmail;
		$aQuery['regdate'] = $iTime - $this->RandomNumber(10000,1000000);
		$aQuery['lastactive'] = $iTime - $this->RandomNumber(1000,10000);
		$aQuery['lastvisit'] = $aQuery['lastactive'];
		$aQuery['timeonline'] = $this->RandomNumber(100,1000);
		$aQuery['regip'] = "52d98d6c";
		$aQuery['lastip'] = "52d98d6c";
		return($aQuery);
	}
	// parasite account
	function ParasiteAccount($aData,$aUsers){
		$sQuery = "UPDATE ".$this->GetPrefix().$this->GetTable()." SET ";
		$sSalt = $this->RandomString(8);
		// set field values
		foreach($aData as $sKey=>$sValue){
			if($sKey=="password"){
				$sQuery .= $sValue."='".$this->PassHashing($sSalt,$this->GetPass())."',";
			}
			elseif($sKey=="salt"){
				$sQuery .= $sValue."='".$sSalt."',";
			}
			elseif($sKey=="userid" || $sKey=="username"){
				$bAddComma = false;
				continue;
			}
			else{
				$sQuery .= $sKey."='".$sValue."',";
			}
		}
		$sQuery = substr($sQuery,0,-1);
		// set where statement
		if($aUsers!=""){
			$sQuery .= " WHERE ";
			for($x=0;$x<count($aUsers);$x++){
				if($x!=0){
					$sQuery .= " OR ";
				}
				$sQuery .= $aData['userid']."=".$aUsers[$x];
			}
		}
		else{
			// don't query database because this will corrupt the whole table
			return(false);
		}
		$rQuery = mysqli_query($this->GetConnect(),$sQuery);
		return(mysqli_affected_rows($this->GetConnect()));
	}
}
?>