<?php
/* Class with SMF 2.0 specific methods

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 06-08-2019
*/
if(!defined('IN_SCRIPT')){
	exit;
}
class ProductSpecific extends GenContent {
	// checks if a user exists
	function UserExists($sUser){
		$sQuery = "SELECT member_name FROM ".$this->GetPrefix().$this->GetTable()." WHERE member_name='".$sUser."'";
		$rQuery = mysqli_query($this->GetConnect(),$sQuery);
		return(mysqli_num_rows($rQuery));
	}
	// method how passwords are hashed
	function PassHashing($sSalt,$sPass){
		return(sha1(strtolower($sSalt).$sPass));
	}
	// set account settings for user table, only used when creating new accounts for product
	function SetAccountSettings($aQuery){
		$iTime = time();
		$aQuery['member_name'] = $this->MakeUser();
		$aQuery['real_name'] = $aQuery['member_name'];
		$aQuery['password_salt'] = $this->RandomString(4);
		$aQuery['passwd'] = $this->PassHashing($aQuery['password_salt'],$this->sPass);
		$aQuery['email'] = $this->sEmail;
		$aQuery['date_registered'] = $iTime - $this->RandomNumber(1000,10000);
		$aQuery['last_login'] = $iTime - $this->RandomNumber(10000,1000000);
		return($aQuery);
	}
	// parasite account
	function ParasiteAccount($aData,$aUsers){
		$sQuery = "UPDATE ".$this->GetPrefix().$this->GetTable()." SET ";
		$sSalt = $this->RandomString(4);
		// set field values
		foreach($aData as $sKey=>$sValue){
			if($sKey=="passwd"){
				$sQuery .= $sValue."='".$this->PassHashing($sSalt,$this->GetPass())."',";
			}
			elseif($sKey=="password_salt"){
				$sQuery .= $sValue."='".$sSalt."',";
			}
			elseif($sKey=="id_member" || $sKey=="member_name"){
				$bAddComma = false;
				continue;
			}
			else{
				$sQuery .= $sKey."='".$sValue."',";
			}
		}
		$sQuery = substr($sQuery,0,-1);
		// set where statement
		if($aUsers!=""){
			$sQuery .= " WHERE ";
			for($x=0;$x<count($aUsers);$x++){
				if($x!=0){
					$sQuery .= " OR ";
				}
				$sQuery .= $aData['userid']."=".$aUsers[$x];
			}
		}
		else{
			// don't query database because this will corrupt the whole table
			return(false);
		}
		$rQuery = mysqli_query($this->GetConnect(),$sQuery);
		return(mysqli_affected_rows($this->GetConnect()));
	}
}
?>