<?php
/* Handler for testing database connection and table properties

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 14-12-2018
*/
if(!defined('IN_SCRIPT')){
	exit;
}
$bProceed = false;
$aAccounts = array();
if(@filesize($sDestAccounts)!=false){
	// there are accounts that we can use for validation
	include($sDestAccounts);
	for($x=0;$x<count($aAccounts);$x++){
		if($aAccounts[$x]['profile_name']==$_POST['sProfileName']){
			$bProceed = true;
			$aAccounts = $aAccounts[$x];
			break;
		}
	}
}
$aDataR['jmessage'] = "<b>Result:</b><p>";
if($bProceed){
	// make a test connection to the database
	if(!$cGen->ConnectDB($aAccounts['database_host'],$aAccounts['database_name'],$aAccounts['database_user'],$aAccounts['database_pass'])){
		$aDataR['jmessage'] .= "Please check your credentials, failed to connect to database";
	}
	else{
		// test table properties
		include($sDestDBFields);
		$cGen->SetPrefix($aAccounts['database_table_prefix']);
		$cGen->SetTable($aAccounts['database_table_users']);
		if(!$cGen->TestQuery($aParasite['fields'],$aAccounts['database_table_users'],$aAccounts['database_table_prefix'])){
			$aDataR['jmessage'] = "Failed selecting data from table";
			die(json_encode($aDataR));
		}
		else{
			$aDataR['jmessage'] .= "Successfully tested table";
			$aDataR['jresult'] = true;
		}
	}
}
else{
	$aDataR['jmessage'] .= "Profile doesn't exist";
}
$aDataR['jmessage'] .= "</p>";
?>