<?php
/* Functions that checks whether a file is there or not 

Will add the error to the context array in case of a failure.

PARAMETERS:
$sFile: path to the local file

RETURNS:
TRUE: the file exists
FALSE: the file doesn't exist

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 04-02-2024
*/

function IsThere($sFile){
	global $_CONTEXT;
	if(!file_exists($sFile)){
		// define the error
		$_CONTEXT['errors'][] = array('error'=>'File <b>'.$sFile.'</b> doesn\'t exist','type'=>'1','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
		return(false);
	}
	return(true);
}
?>