<?php
/* Checks the size of specified files and presents a list of files that exceeded the maximum size

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 15-02-2024
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if($_CONTEXT['allow_filesizescan']){
	$_CONTEXT['scanlabel']['filesizecheck'] = "filesize check";
	$_CONTEXT['filesizecheck'] = "";
	// load the data directory file that contains all core functions or throw a fatal error
	$aRequire = array($_PATHS['data_root']."/monitor_files.php");
	for($x=0;$x<count($aRequire);$x++){
		(!IsThere($aRequire[$x]) ? include_once($_PATHS['end']) : include_once($aRequire[$x]));
	}
	for($x=0;$x<count($_CONTEXT['monitor_f']);$x++){
		$sDest = $_CONTEXT['monitor_f'][$x][0]."/".$_CONTEXT['monitor_f'][$x][1];
		$iSizeB = filesize($sDest);
		$iSizeKB = round($iSizeB/1024);
		if($iSizeKB>$_CONTEXT['maxflsz']){
			$_CONTEXT['filesizecheck'] .= "					<div class=\"a".$x."\">".$sDest." - <a href=\"#\" class=\"deleteeme\" id=\"".$x."\" title=\"".$_CONTEXT['monitor_f'][$x][1]."\">remove ".$iSizeKB." KB</a></div>\n";
		}
	}
	$_CONTEXT['scandata']['filesizecheck'] = $_CONTEXT['filesizecheck'];
}
?>