<?php
/* Content that's displayed on the index page

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 07-02-2024
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if(!isset($_CONTEXT['scanresults']) || !$_CONTEXT['scanresults']){
	$sCode .= "						<div class=\"cc_summary emboss borderr5 border1pxtrans pad5 edgeglow\">\n";
	$sCode .= "							<div class=\"embosshdrnocenter border1pxtrans pad5\">Search</div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<form method=\"post\" class=\"searchquery\"><b>search:</b> <input type=\"text\" name=\"sSearch\" id=\"searchkeyword\" class=\"searchterm\" /></form>\n";
	$sCode .= "								<ul id=\"searchresults\"></ul>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "						</div>\n";
	$sCode .= "						<div class=\"cc_summary emboss borderr5 border1pxtrans pad5 edgeglow\">\n";
	$sCode .= "							<div class=\"embosshdrnocenter border1pxtrans pad5\">CMS Statistics</div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\"><b>current version:</b></div><div class=\"flt pad3\">".$_CONTEXT['version']." - ".$_CONTEXT['updateinfo']."</div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\"><b>server time:</b></div><div class=\"flt pad3\">".date($_CONTEXT['time_pattern'].' H:i:s',time())."</i></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\"><b>installed on:</b></div><div class=\"flt pad3\"> ".date($_CONTEXT['time_pattern'].' H:i:s',$_CONTEXT['useraccessdata']['installed'])."</div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\"><b>last update:</b></div><div class=\"flt pad3\"> ".date($_CONTEXT['time_pattern'].' H:i:s',$_CONTEXT['useraccessdata']['last_update'])."</div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\"><b>last scan:</b></div><div class=\"flt pad3\"> ".($_CONTEXT['useraccessdata']['last_scan']!=0 ? date($_CONTEXT['time_pattern'].' H:i:s',$_CONTEXT['useraccessdata']['last_scan']) : "n/a - <a class=\"wrapcfg\" id=\"20\" href=\"#\">configure maintenance scan</a>")."</div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\"><b>last action:</b></div><div class=\"flt pad3\"> ".$_CONTEXT['useraccessdata']['action']."</div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\"><b>action ip:</b></div><div class=\"flt pad3\"> ".$_CONTEXT['useraccessdata']['ip'][0]."</div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "						</div>\n";
	// see if there are any security notifications to display
	include_once($_PATHS['includes_root']."/cc_sec_notes.php");
	$sCode .= $_CONTEXT['sec_notes'];
	$sCode .= "						<div class=\"cc_summary emboss borderr5 border1pxtrans pad5 edgeglow\">\n";
	$sCode .= "							<div class=\"embosshdrnocenter border1pxtrans pad5\">Maintenance Tools</div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"maintenance.php?type=changes\">find changes since installation</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"maintenance.php?type=evil\">find potentially harmful code</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a class=\"wrapcfg\" id=\"20\" href=\"#\">configure maintenance scan</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"maintenance.php?type=1\">analyze log files for corrupt data</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"maintenance.php?type=2\">find missing functions</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"maintenance.php?type=3\">find obsolete result files</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"maintenance.php?type=0\">find files bigger than ".intval($_CONTEXT['maxflsz'])."KB</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"maintenance.php?type=8\">find outdated modules and apps</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"maintenance.php?type=9\">spider keywords in applications</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "						</div>\n";
	$sCode .= "						<div class=\"cc_summary emboss borderr5 border1pxtrans pad5 edgeglow\">\n";
	$sCode .= "							<div class=\"embosshdrnocenter border1pxtrans pad5\">Help Topics & Quick Start</div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a class=\"wrapcfg\" id=\"12\" href=\"#\">I want to change my security settings</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"maintenance.php?type=all\">I want to do a maintenance scan now</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"configuration.php\">I want to change other configuration settings</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"modules.php\">I want to see which modules have been loaded</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"apps.php\">I want to see the extra apps that are loaded</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"development.php\">I want to create new content</a></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\">- <a href=\"http://hacksuite.com/documentation/index.html\">I want to read the documentation</a> - <i>external</i></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "						</div>\n";
	$sCode .= "						<script type=\"text/javascript\" src=\"Templates/".$_PATHS['style_user']."/js/search.js\"></script>\n";
}
else{
	// by now the html has already been created, we can still edit the existing html
	$_CONTEXT['htmlo'] = str_replace("</head>","<script type=\"text/javascript\" src=\"Templates/".$_PATHS['style_user']."/js/maintenance_run.js\"></script>\n</head>",$_CONTEXT['htmlo']);
}
?>