<?php
/* Automatic server configuration script

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 24-02-2015
*/
if(!defined('IN_SCRIPT')){
	exit;
}
include($_PATHS['data_root']."/logsdata.php");
$sDest = $_PATHS['log_root']."/".$_CONTEXT['l_formats'][2]['file'];
if(!IsThere($sDest)){
	include_once($_PATHS['end']);
}
else{
	if(!function_exists("RawToArray")){
		include_once($_PATHS['functions_root']."/raw_to_array.php");
	}
	if(filesize($sDest)>0){
		if(false!==($aFileData = RawToArray($sDest))){
			// start time bruteforce
			$iStartBF = 0;
			// amount of hits for this 
			$iHits = 0;
			// treshold in seconds
			$iTresholdS = 10;
			// treshold in hits
			$iTresholdH = 10;
			for($x=0;$x<count($aFileData);$x++){
				if($x==0){
					// initialize
					$iStartBF = $aFileData[$x][1];
					$iHits++;
					continue;
				}
				if($aFileData[$x][1]-$iStartBF>$iTresholdS){
					// reset the start time and hit counter
					$iStartBF = $aFileData[$x][0];
					$iHits = 1;
				}
				elseif($aFileData[$x][1]-$iStartBF<=$iTresholdS){
					// still within treshold
					$iHits++;
					// see if we have enough hits
					if($iHits==$iTresholdH){
						$_CONTEXT['bf_detected'] = true;
						break;
					}
				}
			}
		}
	}
}
?>