<?php
/* Edit File handler

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 29-10-2023
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if(!file_exists($sDest)){
	$sCode .= "<div class=\"spacingmsg\">".$_CONTEXT['result_headers']['error']."Invalid source file: ".htmlspecialchars($sDest)."<p><a href=\"development.php?action=list\">[ back ]</a></p></div>\n";
}
else{
	if(!function_exists("GetFileData")){
		@include_once($_PATHS['functions_root']."/get_file_data.php");
	}
	if(!isset($_POST['sNewData'])){
		$sCode = "			<script>\n";
		$sCode .= "			\$(document).on(\"keyup\",\"input.phpscrape\",function(e){\n";
		$sCode .= "				e.preventDefault();\n";
		$sCode .= "				\$('.cc_record#resultsets').remove();\n";
		$sCode .= "				\$.ajax({\n";
		$sCode .= "					type: \"POST\",\n";
		$sCode .= "					url: \"JSON/function_scraper.php\",\n";
		$sCode .= "					data: \"sFunction=\"+\$('input.phpscrape').val(),\n";
		$sCode .= "					dataType: \"json\",\n";
		$sCode .= "					success: function(json){\n";
		$sCode .= "						if(json.jresult==false){\n";
		$sCode .= "							alert(json.jmessage);\n";
		$sCode .= "						}\n";
		$sCode .= "						else{\n";
		$sCode .= "							\$('.cc_record#functions').after('<div class=\"clear\"></div><div class=\"cc_record\" id=\"resultsets\"><div class=\"dissappear flt pad3\" id=\"resultfnc\"></div></div>');\n";
		$sCode .= "							\$.each(json.jresults, function(i, item) {\n";
		$sCode .= "    							\$('.dissappear#resultfnc').append('<a href=\"http://www.php.net/manual/en/'+item[0]+'\" target=\"_blank\">'+item[2]+'</a> <i>'+item[1]+'</i><br />');\n";
		$sCode .= "							});\n";
		$sCode .= "						}\n";
		$sCode .= "					}\n";
		$sCode .= "				});\n";
		$sCode .= "			});\n";
		$sCode .= "			</script>\n";	
		$sCode .= "			<form method=\"post\">\n";
		$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
		$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">edit file</div>\n";
		$sCode .= "				<div class=\"cc_record\" id=\"functions\">\n";
		$sCode .= "					<div class=\"flt pad3\">function</div><div class=\"flt pad3\"><input type=\"text\" name=\"sFunction\" class=\"phpscrape\" value=\"\" /><br /><small>quick lookup for all php functions</small></div>\n";
		$sCode .= "				</div>\n";
		$sCode .= "				<div class=\"clear\"></div>\n";
		$sCode .= "				<div class=\"cc_record\">\n";
		$sCode .= "					<div class=\"flt pad3\">[ edit ]</div><div class=\"flt pad3\"><input type=\"hidden\" name=\"manager\" value=\"editfile\" /><input type=\"hidden\" name=\"sValue\" value=\"".$sDest."\" /><textarea rows=\"15\" cols=\"95\" name=\"sNewData\">".GetFileData($sDest)."</textarea><br /><input type=\"submit\" name=\"submit\" value=\"Edit\" /></div>\n";
		$sCode .= "				</div>\n";
		$sCode .= "				<div class=\"clear\"></div>\n";
		$sCode .= "			</div>\n";
		$sCode .= "			</form>\n";
	}
	else{
		if(!function_exists("WriteF")){
			include_once($_PATHS['functions_root']."/fwrite.php");
		}
		$sCode .= "<div class=\"spacingmsg\">".$_CONTEXT['result_headers']['result'].(WriteF($sDest,$_POST['sNewData'],"w") ? "Successfully edited file" : "Failed to edit file")."<p><a href=\"development.php?action=list\">[ back ]</a></p></div>\n";
	}
}
?>