<?php
/* Automatic server configuration script

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 07-02-2015
*/
if(!defined('IN_SCRIPT')){
	exit;
}
include_once("../vars.php");
if(!$_CONTEXT['allow_testservers']){
	die("Test servers have been disabled in your configuration");
}
if($_CONTEXT['ip_access'] && @is_array($_CONTEXT['ip_allowed'])){
	if(!in_array($_SERVER['REMOTE_ADDR'],$_CONTEXT['ip_allowed'])){
		exit;
	}
}
$_CONFIG = array();
// attempt to get configuration data for this server
$aFileData = @file(str_replace("Logs/","Config/",$sLogFile));
if(is_array($aFileData)){
	// ok we have each line in an array, let's split each line up and fill up the configuration array
	for($x=0;$x<count($aFileData);$x++){
		if(count($aData = @explode("|",$aFileData[$x]))==2){
			if($aData[0]!=""){
				// fill up the configuration array
				$_CONFIG[$aData[0]] = trim($aData[1]);
			}
		}
	}
}
?>