<?php
/*
Handler for Discovery

ModGlue Variables:
$_CONTEXT['thc_ds']['hostparts']['host']
$_CONTEXT['thc_ds']['host']
$_CONTEXT['thc_ds']['load']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 08-05-2024
*/
set_time_limit(0);
// set variable to be able to save a task
$_MODULE_C = "thc_ds";
include_once("../../Includes/screen_header.php");
$sDest = $_PATHS['module_default_root']."/plugins.php";
(!IsThere($sDest) ? include_once($_PATHS['end']) : include_once($sDest));
include_once($_PATHS['style_root']."/screen.php");
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
include_once($_PATHS['functions_root']."/scrn.php");
$_CONTEXT['thc_ds'] = array();
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		case"Discover":
		$_CONTEXT['thc_ds']['hostparts'] = @parse_url($_POST['sHost']);
		if(!isset($_CONTEXT['thc_ds']['hostparts']['host'])){
			die(Screen($sOut."<b id=h7>Host isn't valid</b>".$sEnd."<br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		$_CONTEXT['thc_ds']['host'] = "http://".$_CONTEXT['thc_ds']['hostparts']['host'];
		// go through all plugins and see which and if plugins can be loaded
		$_CONTEXT['thc_ds']['load'] = array();
		foreach($_CONTEXT['plugs'] as $sKey=>$aValues){
			// empty array when no results
			$_CONTEXT['thc_ds'][$aValues[2]] = array();
			if(isset($_POST[$sKey])){
				$_CONTEXT['thc_ds']['load'][] = $aValues[1];
			}
		}
		if(!@count($_CONTEXT['thc_ds']['load'])){
			die(Screen($sOut."No plugins were selected to be loaded".$sEnd."<br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		include($_PATHS['includes_root']."/task_start.php");
		echo Screen($sOut."<br>\n<b>Running scan on ".$_CONTEXT['thc_ds']['host']."..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		// spit fire...
		flush();
		ob_flush();
		break;
		default:
		// default template
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
for($x=0;$x<count($_CONTEXT['thc_ds']['load']);$x++){
	include_once($_PATHS['module_default_root']."/plugins/".$_CONTEXT['thc_ds']['load'][$x]);
}
// update entry in background task file
include($_PATHS['includes_root']."/task_end.php");
echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>
