<?php
/* Enumerates usernames from SMTP

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 07-10-2023
*/
if(!defined('IN_SCRIPT')){
	exit;
}
// commands and success codes
$_CONTEXT['thc_en']['smtp_commands'] = array();
$_CONTEXT['thc_en']['smtp_commands']['RCPT_TO'] = array(250,251);
$_CONTEXT['thc_en']['smtp_commands']['EXPN'] = array(250);
$_CONTEXT['thc_en']['smtp_commands']['VRFY'] = array(250,251);
if(false==($_CONTEXT['thc_en']['connection'] = @fsockopen($_POST['sInput'],$_CONTEXT['thc_en']['port'],$iError,$sError,1))){
	die(Screen("Failed to make a connection with the specified host.<br />\n".$sError." (".$iError.")",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
$_CONTEXT['thc_en']['response'] = fread($_CONTEXT['thc_en']['connection'],1024);
echo Screen($_CONTEXT['thc_en']['response']."<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
fputs($_CONTEXT['thc_en']['connection'],"HELO kitteh\r\n");
$_CONTEXT['thc_en']['response'] = fread($_CONTEXT['thc_en']['connection'],1024);
$_CONTEXT['thc_en']['responsecode'] = substr($_CONTEXT['thc_en']['response'],0,3);
echo Screen($_CONTEXT['thc_en']['response']."<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
flush();
ob_flush();
$_CONTEXT['thc_en']['validcommand'] = "";
if($_CONTEXT['thc_en']['responsecode'][0]=="2"){
	// success, try which method works: VRFY, RCPT TO or EXPN
	for($x=0;$x<$_CONTEXT['thc_en']['userscount'];$x++){
		if($_CONTEXT['thc_en']['validcommand']==""){
			if($x==0){
				// continue until we get a valid command that can verify if a user exists
				foreach($_CONTEXT['thc_en']['smtp_commands'] as $sKey=>$aValues){
					$_CONTEXT['thc_en']['command'] = str_replace("_"," ",$sKey);
					fputs($_CONTEXT['thc_en']['connection'],$_CONTEXT['thc_en']['command']." ".$_CONTEXT['thc_en']['users'][$x]."\r\n");
					// if it's a 502 code, the command is not supported
					$_CONTEXT['thc_en']['response'] = fread($_CONTEXT['thc_en']['connection'],1024);
					$_CONTEXT['thc_en']['responsecode'] = substr($_CONTEXT['thc_en']['response'],0,3);
					$_CONTEXT['thc_en']['responsestart'] = substr($_CONTEXT['thc_en']['responsecode'],0,1);
					if($_CONTEXT['thc_en']['responsecode']=="502"){
						// not implemented, try other command
						echo Screen("Command ".$_CONTEXT['thc_en']['command']." is not implemented<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
						continue;
					}
					elseif($_CONTEXT['thc_en']['responsecode']=="550"){
						// command is accepted, but address is invalid
						$_CONTEXT['thc_en']['validcommand'] = $_CONTEXT['thc_en']['command'];
						echo Screen("<font id=\"h6\">Command ".$_CONTEXT['thc_en']['command']." is supported</font><br /><p><b>Starting enumeration:</b><br /></p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
						echo Screen("User ".$_CONTEXT['thc_en']['users'][$x]." doesn't exist<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
						break;
					}
					else{
						// responses starting with a 2 are valid 
						if($_CONTEXT['thc_en']['responsestart']=="2"){
							$_CONTEXT['thc_en']['validcommand'] = $_CONTEXT['thc_en']['command'];
							$_CONTEXT['thc_en']['valid'][] = $_CONTEXT['thc_en']['users'][$x];
							echo Screen("<font id=\"h6\">Command ".$_CONTEXT['thc_en']['command']." is supported</font><br /><p><b>Starting enumeration:</b><br /></p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
							echo Screen("<font id=\"h6\">User ".$_CONTEXT['thc_en']['users'][$x]." exists</font><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
							break;
						}
						else{
							echo Screen("Command: ".$_CONTEXT['thc_en']['command']." is not implemented<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
						}
					}
					flush();
					ob_flush();
				}
			}
			else{
				// if we still haven't found any method that works, it's time to call it a day
				die(Screen("<p id=h7>Failed to find a method that can be used to enumerate SMTP accounts on the specified host</p>",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		else{
			// we have a valid method
			fputs($_CONTEXT['thc_en']['connection'],$_CONTEXT['thc_en']['validcommand']." ".$_CONTEXT['thc_en']['users'][$x]."\r\n");
			$_CONTEXT['thc_en']['response'] = fread($_CONTEXT['thc_en']['connection'],1024);
			$_CONTEXT['thc_en']['responsecode'] = substr($_CONTEXT['thc_en']['response'],0,3);
			$_CONTEXT['thc_en']['responsestart'] = substr($_CONTEXT['thc_en']['responsecode'],0,1);
			if($_CONTEXT['thc_en']['responsestart']=="2"){
				// starting with a 2 means it's valid
				echo Screen("<font id=h6>User ".$_CONTEXT['thc_en']['users'][$x]." exists</font><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
				$_CONTEXT['thc_en']['valid'][] = $_CONTEXT['thc_en']['users'][$x];
			}
			else{
				echo Screen("User ".$_CONTEXT['thc_en']['users'][$x]." doesn't exist<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
			flush();
			ob_flush();
		}
	}
}
echo Screen("<p>Tried to enumerate ".$_CONTEXT['thc_en']['userscount']." user".($_CONTEXT['thc_en']['userscount']!=1 ? "s" : "").": ".count($_CONTEXT['thc_en']['valid'])." successfully enumerated</p>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>