<?php
/* Windows Apache Check

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 15-08-2024
*/
if(!defined("IN_SCRIPT")){
	exit;
}
$_CONTEXT['thc_hf']['winapache'] = array();
$_CONTEXT['thc_hf']['winapache'][0] = array("Check if ServerTokens is set to 'Prod'","ServerTokens Prod");
$_CONTEXT['thc_hf']['winapache'][1] = array("Check if ServerSignature is set to 'Off'","ServerSignature Off");
$_CONTEXT['thc_hf']['winapache'][2] = array("Check if Directory Listing is disabled","-Indexes");
$_CONTEXT['thc_hf']['winapache'][3] = array("Check if FollowSymLinks is enabled","Options FollowSymLinks");
$_CONTEXT['thc_hf']['winapache'][4] = array("Check if SymLinksIfOwnerMatch is enabled","Options SymLinksIfOwnerMatch");
$_CONTEXT['thc_hf']['winapache'][5] = array("Check if AllowOverride is set to 'None'","AllowOverride None");
$_CONTEXT['thc_hf']['winapache'][6] = array("Check if mod_headers is enabled for security headers","LoadModule headers_module modules/mod_headers.so");
$_CONTEXT['thc_hf']['winapache'][7] = array("Check if X-Frame-Options is set","Header always set X-Frame-Options \"SAMEORIGIN");
$_CONTEXT['thc_hf']['winapache'][8] = array("Check if X-XSS-Protection is set","Header always set X-XSS-Protection \"1; mode=block\"");
$_CONTEXT['thc_hf']['winapache'][9] = array("Check if Content Security Policy (CSP) is set","Header always set Content-Security-Policy");
$_CONTEXT['thc_hf']['winapache'][10] = array("Check if HSTS (HTTP Strict Transport Security) is enabled","Header always set Strict-Transport-Security \"max-age=31536000; includeSubDomains");
$_CONTEXT['thc_hf']['winapache'][11] = array("Check if SSL is enabled (port 443)","<VirtualHost *:443>");
$_CONTEXT['thc_hf']['winapache'][12] = array("Check if HTTP/2 is enabled","Protocols h2 http/1.1");
?>