<?php
/* xIF

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 11-08-2023
*/
if(!defined("IN_SCRIPT")){
	exit;
}
$_CONTEXT['thc_if'] = array();
$_CONTEXT['thc_if']['imagesfolder'] = $_PATHS['module_default_root']."/images";
// type
$_CONTEXT['thc_if']['reportselect'] = "<select name=\"iType\" class=\"types\">\n";
$_CONTEXT['thc_if']['reportselect'] .= "	<option value=\"\" selected>select an option</option>\n";
$_CONTEXT['thc_if']['reportselect'] .= "	<option value=\"0\">search text in images</option>\n";
$_CONTEXT['thc_if']['reportselect'] .= "	<option value=\"1\">dump gps data</option>\n";
$_CONTEXT['thc_if']['reportselect'] .= "	<option value=\"2\">dump meta data</option>\n";
$_CONTEXT['thc_if']['reportselect'] .= "</select>\n";
// folders
$_CONTEXT['thc_if']['methodselect'] = "<select name=\"sFolder\" class=\"folders\">\n";
$aIterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($_CONTEXT['thc_if']['imagesfolder'],FilesystemIterator::SKIP_DOTS),RecursiveIteratorIterator::SELF_FIRST);
// find all folders and subfolders
$_CONTEXT['thc_if']['foldersamount'] = 0;
foreach($aIterator as $oItem){
	if($oItem->isDir()){
		$_CONTEXT['thc_if']['foldersamount']++;
		$sFolder = $oItem->getPathName();
		// remove the main folder path to get the relative path
		$sRelative = str_replace($_CONTEXT['thc_if']['imagesfolder'],"",$sFolder);
		$sFolder = ltrim($sRelative,DIRECTORY_SEPARATOR);
		$_CONTEXT['thc_if']['methodselect'] .= "	<option value=\"".$sFolder."\">".$sFolder."</option>\n";
	}
}
if(!$_CONTEXT['thc_if']['foldersamount']){
	$_CONTEXT['thc_if']['methodselect'] .= "	<option value=\"-1\" disabled>no folders found in /images</option>\n";
}
$_CONTEXT['thc_if']['methodselect'] .= "</select>\n";
/* keeps track of the current row when defining properties, which makes it easier to add and remove new rows */
$_CONTEXT['mfs']['currentrow'] = 0;
/* form properties */
$_CONTEXT['mfs']['module'] = $_CONTEXT['module_current'];
$_CONTEXT['mfs']['form'] = array();
$_CONTEXT['mfs']['form']['target'] = $_CONTEXT['screen']['name'];
$_CONTEXT['mfs']['form']['method'] = "post";
$_CONTEXT['mfs']['form']['action'] = $_CONTEXT['screen']['src'];
/* table */
$_CONTEXT['mfs']['table'] = array();
/* table header */
$_CONTEXT['mfs']['table']['header'] = array();
$_CONTEXT['mfs']['table']['header']['name'] = $_CONTEXT['modules'][$_CONTEXT['mfs']['module']]['name'];
$_CONTEXT['mfs']['table']['header']['description'] = $_CONTEXT['modules'][$_CONTEXT['mfs']['module']]['description'];
/* table rows */
$_CONTEXT['mfs']['table']['rows'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "folder";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $_CONTEXT['thc_if']['methodselect']."<br /><i>folders to check for exif data</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "comparescript";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "type of action";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $_CONTEXT['thc_if']['reportselect']."<br /><i>search or dump exif data in images</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "searchthis";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "find";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<input type=\"text\" name=\"sSearch\" placeholder=\"text to find in image exif data\" /><br /><i>search string to find in exif segments</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "searchthis";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "type of search";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<input type=\"checkbox\" name=\"iRegex\" value=\"1\" /><br /><i>use regular expressions eg '/hacksuite/'</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['value'] = "<div class=\"modrowleft mt5\">".($_CONTEXT['thc_if']['foldersamount']!=0 ? "<input type=\"submit\" name=\"submit\" value=\"Search\" />" : "upload an image folder to /images first")."</div>\n";
// create output form
$sCode = ModForm($_CONTEXT['mfs']);
// js
$sCode .= "<script type=\"text/javascript\">\n";
$sCode .= "\$(document).ready(function(){\n";
$sCode .= "	\$(\".modrow#searchthis\").hide();\n";
$sCode .= "	\$('.types').on('change',function(){\n";
$sCode .= "		if(\$(this).val()==='0'){\n";
$sCode .= "			\$(\".modrow#searchthis\").show();\n";
$sCode .= "		}\n";
$sCode .= "		else{\n";
$sCode .= "			\$(\".modrow#searchthis\").hide();\n";
$sCode .= "		}\n";
$sCode .= "	});\n";
$sCode .= "});\n";
$sCode .= "</script>\n";
?>