<?php
/*
Returns a list of all saved Shodan queries

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 26-09-2023
*/
set_time_limit(0);
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "../..";
include_once("../../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
$aDataR['jmessage'] = "No results found";
if(!IsThere("queries.php")){
	$aDataR['jmessage'] = $_CONTEXT['errors'][count($_CONTEXT['errors'])-1];
	die(json_encode($aDataR));
}
@include("queries.php");
if(!isset($_CONTEXT['shodan_queries'])){
	$aDataR['jmessage'] = "Unexpected or no data in queries.php";
	die(json_encode($aDataR));
}
if(false==($iQueries = @count($_CONTEXT['shodan_queries']))){
	$aDataR['jmessage'] = "No queries in queries.php";
	die(json_encode($aDataR));
}
// valid data, let's turn it into a selection menu
$aDataR['jresult'] = true;
$aDataR['jmessage'] = "<select name=\"sShodanQueries\" class=\"sQuery\">";
for($x=0;$x<$iQueries;$x++){
	$aDataR['jmessage'] .= "<option value=\"".$_CONTEXT['shodan_queries'][$x]['filename']."\">".date($_CONTEXT['time_pattern']." H:i",$_CONTEXT['shodan_queries'][$x]['tstamp'])." - ".$_CONTEXT['shodan_queries'][$x]['keyword']."</option>";
}
$aDataR['jmessage'] .= "</select>";
echo json_encode($aDataR);
?>