<?php
/*
Outputs the converted text or displays the result

ModGlue Variables:
$_CONTEXT['thc_xc']['optionfile']
$_CONTEXT['thc_xc']['items']
$_CONTEXT['thc_xc']['array_index']
$_CONTEXT['thc_xc']['function']
$_CONTEXT['thc_xc']['converter_function_file']
$_CONTEXT['thc_xc']['output']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 25-05-2024
*/
$_MODULE_C = "thc_xc";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['functions_root']."/scrn.php");
if(!isset($_CONTEXT['thc_xc'])){
	$_CONTEXT['thc_xc'] = array();
}
$_CONTEXT['thc_xc']['optionfile'] = $_PATHS['module_default_root']."/convertopt.php";
@include_once($_CONTEXT['thc_xc']['optionfile']);
if(!$_CONTEXT['thc_xc']['items'] = @count($_CONVERT)){
	die(Screen("<br />\n<b>Invalid convert file, expecting convert_opt.php to contain \$_CONVERT</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
$_CONTEXT['thc_xc']['array_index'] = false;
foreach($_CONVERT as $iKey=>$aValues){
	if($aValues['function']==$_POST['sOption']){
		$_CONTEXT['thc_xc']['array_index'] = $iKey;
		break;
	}
}
if($_CONTEXT['thc_xc']['array_index']===false){
	die(Screen("<br />\n<b>Specified function doesn't exist</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// first of all let's see if the method option is valid..
$_CONTEXT['thc_xc']['function'] = @$_CONVERT[$_CONTEXT['thc_xc']['array_index']]['function'];
if(!@function_exists($_CONTEXT['thc_xc']['function'])){
	$_CONTEXT['thc_xc']['converter_function_file'] = $_PATHS['module_default_root']."/CONVERTERS/".$_CONTEXT['thc_xc']['function'].".php";
	if(!file_exists($_CONTEXT['thc_xc']['converter_function_file'])){
		die(Screen("<br />\n<b>Converter file ".$_CONTEXT['thc_xc']['converter_function_file']." doesn't exist, also note that function names should correspond with filenames (function ".$_CONTEXT['thc_xc']['function']." = /CONVERTERS/".$_CONTEXT['thc_xc']['function'].".php)</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
	include_once($_CONTEXT['thc_xc']['converter_function_file']);
	if(!@function_exists($_CONTEXT['thc_xc']['function'])){
		die(Screen("<br />\n<b>Function ".$_CONTEXT['thc_xc']['function']." isn't available</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
$_CONTEXT['thc_xc']['items'] = @count($_CONVERT[$_CONTEXT['thc_xc']['array_index']]['fieldnames']);
$_POST['submit'] = !isset($_POST['submit']) ? "Send" : $_POST['submit'];
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		/* Send */
		case"Send":
		switch($_CONTEXT['thc_xc']['items']){
			case 8:
			$_CONTEXT['thc_xc']['output'] = $_CONTEXT['thc_xc']['function']($_POST['sInput0'],$_POST['sInput1'],$_POST['sInput2'],$_POST['sInput3'],$_POST['sInput4'],$_POST['sInput5'],$_POST['sInput6'],$_POST['sInput7']);
			break;
			case 7:
			$_CONTEXT['thc_xc']['output'] = $_CONTEXT['thc_xc']['function']($_POST['sInput0'],$_POST['sInput1'],$_POST['sInput2'],$_POST['sInput3'],$_POST['sInput4'],$_POST['sInput5'],$_POST['sInput6']);
			break;
			case 6:
			$_CONTEXT['thc_xc']['output'] = $_CONTEXT['thc_xc']['function']($_POST['sInput0'],$_POST['sInput1'],$_POST['sInput2'],$_POST['sInput3'],$_POST['sInput4'],$_POST['sInput5']);
			break;
			case 5:
			$_CONTEXT['thc_xc']['output'] = $_CONTEXT['thc_xc']['function']($_POST['sInput0'],$_POST['sInput1'],$_POST['sInput2'],$_POST['sInput3'],$_POST['sInput4']);
			break;
			case 4:
			$_CONTEXT['thc_xc']['output'] = $_CONTEXT['thc_xc']['function']($_POST['sInput0'],$_POST['sInput1'],$_POST['sInput2'],$_POST['sInput3']);
			break;
			case 3:
			$_CONTEXT['thc_xc']['output'] = $_CONTEXT['thc_xc']['function']($_POST['sInput0'],$_POST['sInput1'],$_POST['sInput2']);
			break;
			case 2:
			$_CONTEXT['thc_xc']['output'] = $_CONTEXT['thc_xc']['function']($_POST['sInput0'],$_POST['sInput1']);
			break;
			case 1:
			$_CONTEXT['thc_xc']['output'] = $_CONTEXT['thc_xc']['function']($_POST['sInput0']);
			break;
			case 0:
			$_CONTEXT['thc_xc']['output'] = $_CONTEXT['thc_xc']['function']();
			break;
		}
		break;
		default:
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
if(isset($_CONVERT[$_CONTEXT['thc_xc']['array_index']]['nl2br'])){
	$_CONTEXT['thc_xc']['output'] = nl2br($_CONTEXT['thc_xc']['output']);
}
echo Screen($_CONTEXT['thc_xc']['output'],$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>
