$(document).ready(function(){
	$('select.commands').change(function(){
		var selectedOption = $(this).find(':selected');
		var matches = selectedOption.val().match(/\[([^\]]+)]/g);
		$('.modrow#temp').remove();
		if(matches){
			matches.forEach(function(match){
				var inputName = match.substring(1,match.length-1);
				var inputElement = $('<input>',{
					type:'text',
					name:inputName,
					placeholder:inputName
				});
				var tempRow = $('<div>',{
					class:'modrow',
					id:'temp'
				});
				var modLeft = $('<div>',{
					class:'modleft',
					text:inputName
				});
				var modRight = $('<div>',{
					class:'modright'
				});
				modRight.append(inputElement);
				tempRow.append(modLeft);
				tempRow.append(modRight);
				$('.modrow#command').after(tempRow);
			});
		}
	});
});