<?php
/*
Handler for xExecute

ModGlue Variables:
$_CONTEXT['thc_xe']['commandfile']
$_CONTEXT['thc_xe']['command']
$_CONTEXT['thc_xe']['commanddata']
$_CONTEXT['thc_xe']['commands']
$_CONTEXT['thc_xe']['commandexists']
$_CONTEXT['thc_xe']['commandexecute']
$_CONTEXT['thc_xe']['commandexecuteoutput']
$_CONTEXT['thc_xe']['commandexecuteraw']
$_CONTEXT['thc_xe']['totaltime']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 25-05-2024
*/
// set variable to be able to save a task
$_MODULE_C = "thc_xe";
$_CONTEXT['thc_xe'] = array();
include_once("../../Includes/screen_header.php");
include_once($_PATHS['functions_root']."/scrn.php");
$_CONTEXT['thc_xe']['commandfile'] = $_PATHS['module_default_root']."/commands.php";
(!IsThere($_CONTEXT['thc_xe']['commandfile']) ? include_once($_PATHS['end']) : include_once($_CONTEXT['thc_xe']['commandfile']));
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
// template for screen file output
include_once($_PATHS['style_root']."/screen.php");
if(!function_exists("shell_exec")){
	die(Screen($sOut."Shell execution isn't enabled in your php configuration",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// Execute
		case"Execute":
		if(isset($_POST['domain'])){
			if(!preg_match('/^([a-zA-Z0-9]+(-[a-zA-Z0-9]+)*\.)+[a-zA-Z]{2,}$/',$_POST['domain'])){
				die(Screen($sOut."Domain name is invalid",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		if(isset($_POST['dscp'])){
			$_POST['dscp'] = @intval($_POST['dscp']);
			if(!preg_match('/^([0-9]|[1-5][0-9]|6[0-3])$/',$_POST['dscp'])){
				die(Screen($sOut."Invalid dscp value",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		if(isset($_POST['hops'])){
			$_POST['hops'] = @intval($_POST['hops']);
			if(!preg_match('/^[1-9][0-9]*$/',$_POST['hops'])){
				die(Screen($sOut."Invalid hops value",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		if(isset($_POST['ms'])){
			$_POST['ms'] = @intval($_POST['ms']);
			if(!preg_match('/^[1-9][0-9]*$/',$_POST['ms'])){
				die(Screen($sOut."Invalid hops value",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		if(isset($_POST['queries'])){
			$_POST['queries'] = @intval($_POST['queries']);
			if(!preg_match('/^[1-9][0-9]*$/',$_POST['queries'])){
				die(Screen($sOut."Invalid queries value",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		if(isset($_POST['port'])){
			$_POST['port'] = @intval($_POST['port']);
			if(!preg_match('/^(0|([1-9]\d{0,3})|([1-5]\d{4})|6[0-4]\d{3}|65[0-4]\d{2}|655[0-2]\d{1}|6553[0-5])$/',$_POST['port'])){
				die(Screen($sOut."Invalid port value",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		if(isset($_POST['host'])){
			if(!preg_match('/^(([a-zA-Z0-9]+(-[a-zA-Z0-9]+)*\.)+[a-zA-Z]{2,}|(\d{1,3}\.){3}\d{1,3}|\[?[0-9a-fA-F:]+\]?)$/',$_POST['host'])){
				die(Screen($sOut."Invalid host value",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		if(isset($_POST['ipv6'])){
			if(filter_var(trim($_POST['ipv6'],"[]"),FILTER_VALIDATE_IP,FILTER_FLAG_IPV6)){
				die(Screen($sOut."Invalid ipv6 address",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		if(isset($_POST['ipv4'])){
			if(filter_var($_POST['ipv4'],FILTER_VALIDATE_IP,FILTER_FLAG_IPV4)){
				die(Screen($sOut."Invalid ipv4 address",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		$_CONTEXT['thc_xe']['command'] = explode(" ",$_POST['sSelectCommand']);
		$_CONTEXT['thc_xe']['commanddata'] = $_CONTEXT['thc_xe']['commands'][$_CONTEXT['thc_xe']['command'][0]]['commands'];
		for($x=0;$x<count($_CONTEXT['thc_xe']['commanddata']);$x++){
			if($_CONTEXT['thc_xe']['commanddata'][$x][0]==$_POST['sSelectCommand']){
				$_CONTEXT['thc_xe']['commandexists'] = true;
				break;
			}
		}
		if(!isset($_CONTEXT['thc_xe']['commandexists'])){
			die(Screen($sOut."Command doesn't exist",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		break;
		default:
		// default template
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
include($_PATHS['includes_root']."/task_start.php");
echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
echo Screen("<br />\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// spit fire...
flush();
ob_flush();
function ReplaceCallback($aMatches) {
	$sKey = $aMatches[1];
	return isset($_POST[$sKey]) ? $_POST[$sKey] : $aMatches[0];
}
$_CONTEXT['thc_xe']['commandexecute'] = preg_replace_callback('/\[(.*?)\]/','replaceCallback',$_POST['sSelectCommand']);
$_CONTEXT['thc_xe']['commandexecuteoutput'] = htmlspecialchars($_CONTEXT['thc_xe']['commandexecute']);
echo Screen("<b>execute command ".$_CONTEXT['thc_xe']['commandexecuteoutput'].":</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
flush();
ob_flush();
echo Screen("<p>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
if(false===($_CONTEXT['thc_xe']['commandexecuteraw'] = @shell_exec($_CONTEXT['thc_xe']['commandexecute']))){
	echo Screen("<b>failed to execute command</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
else{
	echo Screen("<pre>".nl2br($_CONTEXT['thc_xe']['commandexecuteraw'])."</pre>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
echo Screen("</p>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
flush();
ob_flush();
// update entry in background task file
$_CONTEXT['thc_xe']['totaltime'] = time()-$_CONTEXT['start_task'];
include($_PATHS['includes_root']."/task_end.php");
echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>
