<?php
/* Log filename editor

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 08-07-2024
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if(defined('SPIDER')){
	$_CONTEXT['nativekeywords'][24] = array("native","edit","log","log editor","editor","logging");
}
else{
	$_CONTEXT['subtitle'] = "Log Editor";
	$sDest = $_PATHS['data_root']."/logsdata.php";
	(!IsThere($sDest) ? include_once($_PATHS['end']) : include($sDest));
	$sJSDev = "<script type=\"text/javascript\" src=\"Templates/".$_PATHS['style_user']."/js/log_edit.js\"></script>\n";
	$_CONTEXT['headers'] = isset($_CONTEXT['headers']) ? $_CONTEXT['headers'].$sJSDev : $sJSDev;
	$sSelect = "no logs found";
	if(false!==($iSelect = count($_CONTEXT['l_formats']))){
		$sSelect = "<select name=\"sLogName\">";
		$iEditable = 0;
		for($x=0;$x<$iSelect;$x++){
			if($_CONTEXT['l_formats'][$x]['format']['editable']){
				// filter out log files that are allowed to modify
				$iEditable++;
				$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$x]['file']."\">".$_CONTEXT['l_formats'][$x]['file']."</option>\n";
			}
		}
		if(!$iEditable){
			$sSelect .= "<option value=\"-1\">no editable logs</option>\n";
		}
		$sSelect .= "</select>\n";
	}
	$sCode .= "						<form class=\"logform\"><div class=\"cc_summary emboss borderr5 border1pxtrans pad5 edgeglow\">\n";
	$sCode .= "							<div class=\"embosshdrnocenter border1pxtrans pad5\">LOG NAME</div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3 w100\"><b>old name</b></div><div class=\"flt pad3\">".$sSelect."</div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\" id=\"filenames\"></div>\n";
	$sCode .= "							<div class=\"cc_record\">\n";
	$sCode .= "								<div class=\"flt pad3\"><input type=\"submit\" name=\"submit\" class=\"editfile\" value=\"Edit\" /></div>\n";
	$sCode .= "							</div>\n";
	$sCode .= "							<div class=\"clear\"></div>\n";
	$sCode .= "						</div></form>\n";
}
?>