$(document).on("change","select.updateme",function(event){
	/* default selection */
	if($(this).val()==-1){
		alert('Please select an option');
	}
	/* enable or disable maintenance scans */
	else if($(this).val()==0){
		$('.dholder').html('<div class="datawrap">');
		$('.datawrap').append('	<div class="datarowh">variable allow_maintenance</div>');
		$('.datawrap').append('	<div class="datarow">');
		$('.datarow').append('		<div class="datafieldl w200">maintenance scan</div>');
		$('.datarow').append('		<div class="datafieldr">'+($('.defvals .allow_maintenance_scan').val()=='1' ? 'disable' : 'enable')+' <input type="checkbox" name="iUpdate" value="1" /><br />- selection inverts current setting!</div>');
		$('.datarow').append('	</div');
		$('.datawrap').append('</div>');
	}
	/* scan for log,configuration and data files that became bigger than $_CONTEXT['maxflsz'] */
	else if($(this).val()==1){
		$('.dholder').html('<div class="datawrap">');
		$('.datawrap').append('	<div class="datarowh">variable allow_filesizescan</div>');
		$('.datawrap').append('	<div class="datarow">');
		$('.datarow').append('		<div class="datafieldl w200">file scan</div>');
		$('.datarow').append('		<div class="datafieldr">'+($('.defvals .allow_filesizescan').val()=='1' ? 'disable' : 'enable')+' <input type="checkbox" name="iUpdate" value="1" /><br />- selection inverts current setting!</div>');
		$('.datarow').append('	</div');
		$('.datawrap').append('</div>');
	}
	/* maximum filesize of log,configuration and data files in KB */
	else if($(this).val()==2){
		$('.dholder').html('<div class="datawrap">');
		$('.datawrap').append('	<div class="datarowh">variable maxflsz</div>');
		$('.datawrap').append('	<div class="datarow">');
		$('.datarow').append('		<div class="datafieldl w200">file size</div>');
		$('.datarow').append('		<div class="datafieldr"><input type="text" size="35" name="iFileSize" value="'+$('.defvals .maxflsz').val()+'" /><br />- size must be integer<br />- size is in KB</div>');
		$('.datarow').append('	</div');
		$('.datawrap').append('</div>');
	}
	/* analyzes logfiles */
	else if($(this).val()==3){
		$('.dholder').html('<div class="datawrap">');
		$('.datawrap').append('	<div class="datarowh">variable allow_logfileanalyze</div>');
		$('.datawrap').append('	<div class="datarow">');
		$('.datarow').append('		<div class="datafieldl w200">file scan</div>');
		$('.datarow').append('		<div class="datafieldr">'+($('.defvals .allow_filesizescan').val()=='1' ? 'disable' : 'enable')+' <input type="checkbox" name="iUpdate" value="1" /><br />- selection inverts current setting!</div>');
		$('.datarow').append('	</div');
		$('.datawrap').append('</div>');
	}
	/* checks if all required functions are there */
	else if($(this).val()==4){
		$('.dholder').html('<div class="datawrap">');
		$('.datawrap').append('	<div class="datarowh">variable allow_functcheck</div>');
		$('.datawrap').append('	<div class="datarow">');
		$('.datarow').append('		<div class="datafieldl w200">file scan</div>');
		$('.datarow').append('		<div class="datafieldr">'+($('.defvals .allow_filesizescan').val()=='1' ? 'disable' : 'enable')+' <input type="checkbox" name="iUpdate" value="1" /><br />- selection inverts current setting!</div>');
		$('.datarow').append('	</div');
		$('.datawrap').append('<div class="clear"></div>');
	}
	/* count the files in specific folders in order to minimize the amount of garbage */
	else if($(this).val()==5){
		$('.dholder').html('<div class="datawrap">');
		$('.datawrap').append('	<div class="datarowh">variable allow_filesindirscan</div>');
		$('.datawrap').append('	<div class="datarow">');
		$('.datarow').append('		<div class="datafieldl w200">file scan</div>');
		$('.datarow').append('		<div class="datafieldr">'+($('.defvals .allow_filesizescan').val()=='1' ? 'disable' : 'enable')+' <input type="checkbox" name="iUpdate" value="1" /><br />- selection inverts current setting!</div>');
		$('.datarow').append('	</div');
		$('.datawrap').append('</div>');
	}
	/* maximum files in dir before reporting */
	else if($(this).val()==6){
		$('.dholder').html('<div class="datawrap">');
		$('.datawrap').append('	<div class="datarowh">variable maxflsindir</div>');
		$('.datawrap').append('	<div class="datarow">');
		$('.datarow').append('		<div class="datafieldl w200">file amount</div>');
		$('.datarow').append('		<div class="datafieldr"><input type="text" name="iFiles" value="'+$('.defvals .maxflsindir').val()+'" /><br />- maximum files before sending report</div>');
		$('.datarow').append('	</div');
		$('.datawrap').append('</div>');
	}
	/* the global interval between a next maintenance scan */
	else if($(this).val()==7){
		$('.dholder').html('<div class="datawrap">');
		$('.datawrap').append('	<div class="datarowh">variable nextscanseconds</div>');
		$('.datawrap').append('	<div class="datarow">');
		$('.datarow').append('		<div class="datafieldl w200">scan interval</div>');
		$('.datarow').append('		<div class="datafieldr"><input type="text" name="iAmount" value="'+$('.defvals .nextscanseconds').val()+'" /><br />- minimum amount of seconds before next scan</div>');
		$('.datarow').append('	</div');
		$('.datawrap').append('</div>');
	}
	/* version check for tools */
	else if($(this).val()==8){
		$('.dholder').html('<div class="datawrap">');
		$('.datawrap').append('	<div class="datarowh">variable allow_version_check</div>');
		$('.datawrap').append('	<div class="datarow">');
		$('.datarow').append('		<div class="datafieldl w200">check</div>');
		$('.datarow').append('		<div class="datafieldr">'+($('.defvals .allow_version_check').val()=='1' ? 'disable' : 'enable')+' <input type="checkbox" name="iUpdate" value="1" /><br />- selection inverts current setting!</div>');
		$('.datarow').append('	</div');
		$('.datawrap').append('</div>');
	}
	/* spider for keywords in native,apps and modules */
	else if($(this).val()==9){
		$('.dholder').html('<div class="datawrap">');
		$('.datawrap').append('	<div class="datarowh">variable keywords_spider</div>');
		$('.datawrap').append('	<div class="datarow">');
		$('.datarow').append('		<div class="datafieldl w200">check</div>');
		$('.datarow').append('		<div class="datafieldr">'+($('.defvals .allow_version_check').val()=='1' ? 'disable' : 'enable')+' <input type="checkbox" name="iUpdate" value="1" /><br />- selection inverts current setting!</div>');
		$('.datarow').append('	</div');
		$('.datawrap').append('</div>');
	}
	/* invalid choice */
	else{
		alert('Invalid selection, please make a valid selection');
	}
});
$(document).on("submit","form.security",function(event){
	event.preventDefault();
	dataString = $("form.security").serialize();
	$.ajax({
		type: "POST",
		url: "JSON/maintenance_scan.php",
		data: dataString,
		dataType: "json",
		beforeSend:function() {
			$('.newmodule').hide('slow');
		},
		success: function(json){
			if(json.jresult==false){
				alert(json.jmessage);
			}
			else{
				if(json.jref){
					$("."+$('div.datarowh').val()).html(json.jref);
				}
				if(json.jredirect){
					document.location.href = 'setup.php';
				}
				$('.datawrap').remove();
				$('.dholder').html('<div class="datawrap">');
				$('.datawrap').append('	<div class="datarow">'+json.jmessage+'</div');
				$('.datarow').append('</div');
			}
		}
	});
});