$(document).on("click","button.upload",function(event){
	event.preventDefault();
	const sFileInput = document.getElementById('sFileInput');
	const sFile = sFileInput.files[0];
	const sTool = document.getElementById('tool').value;
	if(!sFile){
		alert('Please select a file.');
		return;
	}
	const image = new Image();
	const reader = new FileReader();
	reader.onload = function(e){
		image.src = e.target.result;
		image.onload = function(){
			if(image.width===200 && image.height===200){
				const formData = new FormData();
				formData.append('sFile',sFile);
				formData.append('sTool',sTool);
				$.ajax({
					url: "JSON/development.php",
					type: "POST",
					data: formData,
					contentType: false,
					processData: false,
					success: function(data){
						alert(data.jerror);
					},
					error: function(error){
						console.error('Error:', error);
					}
				});
			}
			else{
				alert('Invalid dimensions. Image must be 200x200 pixels.');
			}
		};
	};
	reader.readAsDataURL(sFile);
});